/*	Fichero dialogofotosensor.h
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un pulsador	
	
	Ultima actualizacion: Viernes 6-10-2006
*/


#ifndef _dialogofotosensor_h
#define _dialogofotosensor_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"

#include "dialogo.h"
#include "fotosensor.h"

/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {
	ID_DIALOGO_ELECTROIMAN=7700,
	ID_VOLTAJE_ACTIVACION_ELECTROIMAN,	ID_VOLTAJE_REPOSO_ELECTROIMAN, 
	ID_MAGNETISMO_REPOSO_ELECTROIMAN, ID_MAGNETISMO_ACTIVACION_ELECTROIMAN
};

class DialogoFotoSensor : public Dialogo
{
	DECLARE_CLASS (DialogoFotoSensor)
	DECLARE_EVENT_TABLE()
	public: 
		DialogoFotoSensor ();
		DialogoFotoSensor ( 	wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_ELECTROIMAN,
							const wxString& titulo= wxT ("Configurar fotosensor"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();

		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
		
		void 		OnCReposoActualizado ( wxCommandEvent& evento  );

		void 		OnCActivacionActualizado ( wxCommandEvent& evento  );
	private:
		
		
};

#endif
