/*	Fichero dialogorele.h
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un rele
	
	Ultima actualizacion: Sabado 4-11-2006
*/


#ifndef _dialogorele_h
#define _dialogorele_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"

#include "dialogo.h"
#include "rele.h"

/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {	
		ID_DIALOGO_RELE=8480	,
		ID_VOLTAJE_ACTIVACION_RELE ,
		ID_VOLTAJE_REPOSO_RELE ,
		ID_CONEXION_ACTIVACION_RELE ,
		ID_CONEXION_REPOSO_RELE 
};

class DialogoRele : public Dialogo
{
	DECLARE_CLASS (DialogoRele)
	DECLARE_EVENT_TABLE()
	public: 
		DialogoRele ();
		DialogoRele ( 	wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_RELE,
							const wxString& titulo= wxT ("Configurar rel"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();

		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
		
		/*	Gestores de eventos, comprueban que no se pueda seleccionar
			a la vez activado o desactivado en ambos choices */
		void 		OnCReposoActualizado ( wxCommandEvent& evento  );
		void 		OnCActivacionActualizado ( wxCommandEvent& evento  );

	private:
		
		/*	Estos nombres de variable no son del todo representativos,
			ya que el usuario puede invertir los valores y escribir que
			por ejemplo 0V es el voltaje que el pulsador emite cuando se
			pulsa. Se usan estos nombres porque por defecto se usaran
			0V para el reposo y "false" para el estado no-conectado*/
		char	nombreElemento[MAX_LONG_NOMBRE_ELEMENTO];
		
		
		/*	Los controles. */
		wxBoxSizer *contenedorCentral;
		wxBoxSizer *contenedorReposo;
		wxBoxSizer *contenedorActivacion;
		wxBoxSizer *contenedorFrecuencia;
		
		wxStaticText *lblVoltajeEntrada;
		wxStaticText *lblZumbidoReposo;
		wxStaticText *lblVoltajeActivacion;
	    wxStaticText *lblZumbidoActivacion;
		wxStaticText *lblFrecuencia;
		
		wxSpinCtrl *spnVReposo;
	    wxSpinCtrl *spnVActivacion;
	    wxSpinCtrl *spnFrecuencia;	
	    
	    wxChoice *chcConexionReposo;
		wxChoice *chcConexionActivacion;	    
};

#endif
