#include "contadorvisual.h"

ContadorVisual::ContadorVisual()
{	
	/*	El bitmap ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
		wxString ficheroIcono ("iconos/Contador.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);
		
		wxString ficheroIconoInactivo ("iconos/ContadorInactivo.xpm");
		bitmapElementoInactivo.LoadFile(ficheroIconoInactivo, TIPO_ICONOS);
		
		wxString ficheroIconoActivo ("iconos/ContadorActivo.xpm");
		bitmapElementoActivo.LoadFile(ficheroIconoActivo, TIPO_ICONOS);
		
		bitmapEnPantalla = bitmapElementoInactivo;
		
		estado_actual = INACTIVO;
		
		/* Se crea el contador */
		unsigned int maxPulsos 					=	5;
		
		Voltaje* voltajeEntradaReposo		=	new Voltaje(0.0);
		Voltaje* voltajeEntradaActivacion	=	new Voltaje(5.0);

		Voltaje* voltajeSalidaReposo		=	new Voltaje(0.0);
		Voltaje* voltajeSalidaActivacion	=	new Voltaje(5.0);
		
		elementoEnvuelto = new Contador(maxPulsos, voltajeEntradaReposo,
			voltajeEntradaActivacion, voltajeSalidaReposo, voltajeSalidaActivacion);
		
		senalReposo 		= voltajeEntradaReposo;
		senalActivacion 	= voltajeEntradaActivacion;
		SetNombre ("Contador");
}

void ContadorVisual::setElementoEnvuelto (Elemento* e)
{
	wxLogMessage ("---ContadorVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (e);
	Contador* contador = dynamic_cast<Contador*> (e);
	senalReposo 	= contador->getVoltajeEntradaReposo();
	senalActivacion = contador->getVoltajeEntradaActivacion();
	SetNombre (e->getNombreElemento());
	
}
Dialogo* ContadorVisual::FabricarDialogo()
{
	return new DialogoContador();
}

void ContadorVisual::manejarEntrada (Senal* s, int posicion)
{
	/*El icono y el estado solo cambian si el contador ha
		llegado a la cuenta maxima */
	if (estado_actual == INACTIVO)
	{
		Contador* temporizadorEnvuelto 	= dynamic_cast<Contador*> 
											(elementoEnvuelto);
		int cuenta_actual 	= temporizadorEnvuelto->getNumPulsos();
		int cuenta_total	= temporizadorEnvuelto->getMaxPulsos();
		
		wxLogMessage ("Pulsos actuales %i, Max pulsos %i", 
			cuenta_actual, cuenta_total);
		if (cuenta_actual == cuenta_total)
		{
			bitmapEnPantalla = bitmapElementoActivo;
			estado_actual = ACTIVO;
			return;
		}
	} /* Fin del if para INACTIVO*/
	
	if (estado_actual == ACTIVO)
	{
	} /* Fin del if para ACTIVO*/
}
