#include "fotosensorvisual.h"

FotosensorVisual::FotosensorVisual()
{	
	/*	El bitmap ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
		wxString ficheroIcono ("iconos/Fotosensor.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);
		
		wxString ficheroIconoInactivo ("iconos/FotosensorInactivo.xpm");
		bitmapElementoInactivo.LoadFile(ficheroIconoInactivo, TIPO_ICONOS);
		
		wxString ficheroIconoActivo ("iconos/FotosensorActivo.xpm");
		bitmapElementoActivo.LoadFile(ficheroIconoActivo, TIPO_ICONOS);
		
		bitmapEnPantalla = bitmapElementoInactivo;
		
		estado_actual = INACTIVO;
		
		Voltaje* 		voltajeSalidaReposo		=	new Voltaje(0.0);
		Voltaje* 		voltajeSalidaActivacion	=	new Voltaje(5.0);
		Luminosidad* 	luminosidadReposo		=	new Luminosidad("000000");
		/*	Por defecto. Se usan bombillas blancas. Que ahorran energa ;) */
		Luminosidad* luminosidadActivacion		=	new Luminosidad("ffffff");
		
		elementoEnvuelto=new FotoSensor(luminosidadReposo, luminosidadActivacion,
			voltajeSalidaReposo, voltajeSalidaActivacion);
		SetNombre ("Fotosensor");
}
void FotosensorVisual::setElementoEnvuelto (Elemento* e)
{
	wxLogMessage ("---FotosensorVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (e);
	FotoSensor* fotosensor = dynamic_cast<FotoSensor*> (e);
	senalReposo 	= fotosensor->getLuminosidadEntradaReposo();
	senalActivacion = fotosensor->getLuminosidadEntradaActivacion();
	SetNombre (e->getNombreElemento());
	
}
Dialogo* FotosensorVisual::FabricarDialogo()
{
	return new DialogoFotoSensor();
}

void FotosensorVisual::ManejarEntrada (Senal* s, int posicion)
{
	wxLogMessage ("Se ha modificado la entrada del fotosensor");
}

