#include "pulsadorvisual.h"

PulsadorVisual::PulsadorVisual()
{	
	/*	El bitmap que representa este pulsador ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
//		#include "../iconos/Pulsador.xpm"
//		bitmap.Create ( Pulsador, TIPO_ICONOS, 
//			ANCHURA_ICONOS, ALTURA_ICONOS, PROFUNDIDAD_DE_COLOR )		
		wxString ficheroIcono ("iconos/Pulsador2Inactivo.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);
		
		wxString ficheroIconoInactivo ("iconos/Pulsador2Inactivo.xpm");
		bitmapElementoInactivo.LoadFile(ficheroIconoInactivo, TIPO_ICONOS);
		
		wxString ficheroIconoActivo ("iconos/Pulsador2Activo.xpm");
		bitmapElementoActivo.LoadFile(ficheroIconoActivo, TIPO_ICONOS);
		
   		SetNombre ("Pulsador");
   		estado_actual = INACTIVO;
   		elementoEnvuelto = new Pulsador ( new Conexion(false), 
								new Voltaje(0.0),
								new Conexion(true),
								new Voltaje(5.0) );
		bitmapEnPantalla = bitmapElementoInactivo;
		
		/* Se toma nota de los valores necesarios para que el elemento
			pase a estado de reposo o de activacion */
		Pulsador* aux = dynamic_cast<Pulsador*> (elementoEnvuelto);
		senalReposo 	= aux->getConexionReposo();
		senalActivacion	= aux->getConexionActivacion();
		wxLogMessage ("Constructor de pulsador visual finalizado");
}

void PulsadorVisual::setElementoEnvuelto (Elemento* e)
{	
	ElementoVisual::setElementoEnvuelto (e);
	Pulsador* pulsador = dynamic_cast<Pulsador*> (e);
	elementoEnvuelto = pulsador;
	senalReposo 	= pulsador->getConexionReposo();
	senalActivacion = pulsador->getConexionActivacion();
	SetNombre (e->getNombreElemento());
	wxLogMessage ("Conexiones obtenidas");	
}

Dialogo* PulsadorVisual::FabricarDialogo()
{
//	wxMessageBox ("El pulsador devuelve un dialogo especial");
	return new DialogoPulsador();
}



