#include "zumbadorvisual.h"

ZumbadorVisual::ZumbadorVisual()
{	
	/*	El bitmap ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
		wxString ficheroIcono ("iconos/Zumbador.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);
		
		wxString ficheroIconoInactivo ("iconos/ZumbadorInactivo.xpm");
		bitmapElementoInactivo.LoadFile(ficheroIconoInactivo, TIPO_ICONOS);
		
		wxString ficheroIconoActivo ("iconos/ZumbadorActivo.xpm");
		bitmapElementoActivo.LoadFile(ficheroIconoActivo, TIPO_ICONOS);
		
		
		Voltaje* voltajeReposo		=	new Voltaje(0.0);
		Voltaje* voltajeActivacion	=	new Voltaje(5.0);

		Frecuencia* frecuenciaReposo		= 	new Frecuencia(0);
		Frecuencia* frecuenciaActivacion	=	new Frecuencia(30000);
		
		elementoEnvuelto = new Zumbador (voltajeReposo, frecuenciaReposo, 
			voltajeActivacion, frecuenciaActivacion);
		
		estado_actual = INACTIVO;
		
		bitmapEnPantalla = bitmapElementoInactivo;
		
		SetNombre ("Zumbador");
		senalReposo 	= voltajeReposo;
		senalActivacion	= voltajeActivacion;
}

void ZumbadorVisual::setElementoEnvuelto (Elemento* e)
{
	wxLogMessage ("---ZumbadorVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (e);
	Zumbador* zumbador = dynamic_cast<Zumbador*> (e);
	senalReposo 	= zumbador->getVoltajeReposo();
	senalActivacion = zumbador->getVoltajeActivacion();
	SetNombre (e->getNombreElemento());
	
}

Dialogo* ZumbadorVisual::FabricarDialogo()
{
	return new DialogoZumbador();
}
