#ifndef _evento_click_notebook_h
#define _evento_click_notebook_h
//in .h

//Define our event types - we need to call DEFINE_EVENT_TYPE(EVT) later
DECLARE_EVENT_TYPE(wxEVT_CLICK_NOTEBOOK, wxEVT_CLICK)

class wxEvtClickNotebook : public wxNotifyEvent
{
public:
    // ------------------------------------------------------------------------
    // wxEvtClickNotebook Constructor
    //
    // Normal constructor, much the same as wxNotifyEvent
    // ------------------------------------------------------------------------
    wxEvtClickNotebook(wxEventType commandType = wxEVT_NULL, int id = 0)
        : wxNotifyEvent(commandType)
    {                 letra='A';                      }

    // ------------------------------------------------------------------------
    // wxEvtClickNotebook Copy Constructor
    //
    // Normal copy constructor, much the same as wxNotifyEvent
    // ------------------------------------------------------------------------
    wxEvtClickNotebook(const wxEvtClickNotebook &clone)
            : wxNotifyEvent(clone), x(clone.x), y(clone.y), letra ('a')
    {    	}

    /*	No utilizo el constructor de copia, sino que
    	construyo un elemento igual */
    virtual wxEvent *Clone() const
    {   
		return new wxEvtClickNotebook(*this);
	}
    
    int getX()
    {
		return this->x;
	}
	int getY()
    {
		return this->y;
	}
	void setX(int x)
	{
		this->x=x;
	}
	void setY(int y)
	{
		this->y=y;
	}
	char getName()
	{
		return letra;
	}

    // Put this class on wxWidget's RTTI table
    DECLARE_DYNAMIC_CLASS(wxEvtClickNotebook)
    
    private:
		/* Son las posiciones donde se produjo el evento*/
		int x;
		int y;
		char letra;
};

//Event ID to give to our events
#define wxEVT_CLICK    13000
#define wxMEDIA_STOP_ID    13001



//Function type(s) our events need
typedef void (wxEvtHandler::*wxEvtClickNotebookFunction)(wxEvtClickNotebook&);

//Macro for usage with message maps
#define EVT_CLICK_NOTEBOOK(winid, fn) DECLARE_EVENT_TABLE_ENTRY( wxEVT_CLICK_NOTEBOOK, winid, wxID_ANY, (wxObjectEventFunction) (wxEventFunction) (wxEvtClickNotebookFunction) & fn, (wxObject *) NULL ),
#define EVT_MEDIA_STOP(winid, fn) DECLARE_EVENT_TABLE_ENTRY( wxEVT_MEDIA_STOP, winid, wxID_ANY, (wxObjectEventFunction) (wxEventFunction) (wxEvtClickNotebookFunction) & fn, (wxObject *) NULL ), 

#endif
