/* 	Este archivo contiene algunos mtodo privados y auxiliares
	de la clase Pagina. Se han separado para que el conjunto de
	cdigo sea ms fcil de manejar */

#include "pagina.h"

void Pagina::SetValoresIniciales()
{
	wxLogMessage ("----Pagina::SetValoresIniciales----");
	wxLogMessage ("Fichero %s, linea %i", __FILE__, __LINE__);
	
	this->SetBackgroundColour (wxColour (255,255,255));
	
	/*	Estado inicial */	
	estado_actual 	= INICIAL;
	/*	No se est conectando ningn elemento */
	elemento_emisor = elemento_receptor = NULL;
	
	/*	En general, cuando las paginas se
		crean no estn en el modo simulacion sino en
		construccion */
	modoSimulacion = false;
	
//	wxLogMessage ("Pagina creandose");
	for (int i=0; i<TOTAL_ELEMENTOS; i++)
	{
		numElementos[i]=1; /*Los elementos se empiezan a numerar por 1*/
	}
	
	wxLogMessage ("----Pagina::SetValoresIniciales (Fin de metodo)----");
	wxLogMessage ("Fichero %s, linea %i", __FILE__, __LINE__);
}


void Pagina::ComprobarPuntero (void* puntero)
{
	if (puntero==NULL)
	{
		wxLogMessage ("El puntero era NULL");
	}
	else
	{
//		wxLogMessage ("El puntero no era NULL");
	}
}

void Pagina::ConectarElementos (ElementoVisual* primario, ElementoVisual* secundario,
					int pos_salida_del_emisor, int pos_entrada_del_receptor)
{
	wxLogMessage ("---Pagina::ConectarElementos---");
	//bool primario_null = (primario==NULL);
//	bool secundario_null = (secundario==NULL);
	
	//wxCHECK_RET (!primario_null, "El primario es NULL!");
	//wxCHECK_RET (!secundario_null,"El secundario es NULL!");
	//wxCHECK_RET (pos_salida_del_emisor <=0, "La salida del emisor es invalida");
	//wxCHECK_RET (pos_entrada_del_receptor >=0, "La entrada del receptor es invalida");
	Sistema* contenedorPrimario;
	Sistema* contenedorSecundario;
	
	contenedorPrimario 		= (Sistema*) primario->GetPadre();
	contenedorSecundario 	= (Sistema*) secundario->GetPadre();
	wxLogMessage ("Obtenidos contenedores de primario y secundario");
	/*	No se permite a los usuarios que conecten elementos que no
		estn dentro del mismo sistema o subsistema (o sea, dentro
		de la misma pgina. Es un requisito de diseo, para intentar
		forzar un poco a que los diseos sean ms limpios */	
	if (contenedorPrimario == contenedorSecundario)
	{
		if (!SonElementosConectables (primario, secundario))
		{
			return ;
		}
		wxString nombreSistema (contenedorPrimario->getNombreElemento());
		int num_suscriptores_antes = primario->getTotalSuscripciones();
//		wxLogMessage (wxString ("El padre de ambos es ") + nombreSistema);
		int codigo = primario->Conectar(secundario, 
			pos_entrada_del_receptor, pos_salida_del_emisor);
		int num_suscriptores_despues = primario->getTotalSuscripciones();
		//wxLogMessage ("Suscriptores antes: %i, suscriptores despues: %i", 
//				num_suscriptores_antes,	num_suscriptores_despues);
		assert (num_suscriptores_despues == num_suscriptores_antes+1);
		assert (codigo == 0);
		/* Estos limites para el numero de posicion de entrada o salida
			me parecieron logicos en su momento */
		assert ( (pos_entrada_del_receptor>=0 ) 
			&& (pos_entrada_del_receptor<=10000));
		assert ( (pos_salida_del_emisor>=0) 
			&& (pos_salida_del_emisor<=10000));
		//wxLogMessage ("La salida %i se une a la entrada %i", 
//			pos_salida_del_emisor, pos_entrada_del_receptor);
	}
//	wxMessageBox ("Se ha llamado a conectar elementos");
} /* Fin de conectarelementos*/

/*	Este metodo comprueba si los elementos se pueden relacionar */
bool Pagina::SonElementosConectables (ElementoVisual* primario, 
			ElementoVisual* secundario)
{
	assert (primario!=NULL);
	assert (secundario!=NULL);
	wxLogMessage("---Pagina::SonElementosConectables---");
	int tipoSalidaEmisor 	= primario->getTipoSalida();
	int tipoEntradaReceptor = secundario->getTipoEntrada();
	
	if (tipoSalidaEmisor != tipoEntradaReceptor)
	{
		wxString nombrePrimario 	= primario->GetNombre();
		wxString nombreSecundario 	= secundario->GetNombre();
		wxMessageBox ("No puede conectar la salida de "+
			nombrePrimario+" a "+ nombreSecundario+
			".\nLos tipos de seales no coinciden.", "Conexion imposible");
		return false;
	}
	wxLogMessage ("---fin de Pagina::SonElementosConectables---");
	/* Esto ocurre si los tipos de los elementos son compatibles */
	return true;
}



/****************************GESTORES DE EVENTOS*************************/

void Pagina::OnBotonPulsado (wxPoint punto_del_click)
{
	
	/*	Cuando se ha hecho click en el panel se lanza un
		evento indicando que esta es la ventana lanzadora del evento,
		que ser procesado por la clase Ventana, la cual
		comprobar si debe soltar un elemento en el panel*/
	 wxEvtClickNotebook eventoALanzar(wxEVT_CLICK_NOTEBOOK); 
	 eventoALanzar.setX ( punto_del_click.x );
	 eventoALanzar.setY ( punto_del_click.y );
	
	 wxPostEvent(this, eventoALanzar);
	 
}

void Pagina::OnDobleClick (wxPoint punto_del_doble_click)
{
	ElementoVisual *elemento_encontrado;
	
	/*	Se busca un elemento en esa posicion */
	elemento_encontrado = BuscarElemento (punto_del_doble_click);
	
	/*	Si lo hay.... */
	if (elemento_encontrado != NULL)
	{
		/*	...se configura */
			elemento_encontrado->Configurar();
			wxClientDC contextoDC(this);
			Dibujar (contextoDC);
			return ;
	}
	
	/*	en cualquier otro caso no se hace nada */
	return ;
}

void Pagina::ProcesarPulsacion	( wxMouseEvent& evento )
{
	ElementoVisual* figura;
	if ( evento.LeftUp() && 
			( (figura=BuscarElemento(evento.GetPosition()))!=NULL ) )
	{
		int totalSuscripciones = figura->getTotalSuscripciones();
		assert (totalSuscripciones>=0);
		figura->ConmutarEntrada();
		/*	Despues de conmutar la entrada de un elemento nos aseguramos
			de volver a repintar todo con ReiniciarEstado. Tal vez se podra
			usar simplemente una creacion de DC y llamar a Dibujar, pero
			se ahorra un poco de cdigo, queda igual de claro y funciona
			igual de bien*/
		ReiniciarEstado();
	}
}
void Pagina::OnRaton ( wxMouseEvent& evento )
{
	ElementoVisual*	figura=NULL;
	/*	Si estamos en el modo simulacion el evento se procesa
		de forma distinta */
	if (modoSimulacion) 
	{
		ProcesarPulsacion (evento);
		return ;
	}
	/*	Si el usuario ha hecho click en el derecho ... */
	if (evento.RightUp())
	{
		/*... es porque quiere intentar configurar algo...*/
		#ifdef DEBUG_ON_RATON
			wxLogMessage ("Configurando en (%i, %i)", evento.GetPosition().x,
							evento.GetPosition().y );
		#endif
		
		OnDobleClick (evento.GetPosition());
		ReiniciarEstado ();
		return ;
	} /*Fin del if Rightup*/
	
	if ( estado_actual == INICIAL )
	{
		/*	Si se pulsa el boton y se encuentra una figura...*/
		if ( evento.LeftIsDown() && 
			( (figura=BuscarElemento(evento.GetPosition()))!=NULL ) )
		{
			/*... es posible que esa figura vaya a ser un elemento
				emisor. Se toma nota de ella, se selecciona 
				y se cambia de estado*/
			elemento_emisor = figura ;
			estado_actual	= EN_ESPERA ;
			
			/*	Y tambin es posible que esa figura vaya a ser arrastrada, as
				que se marca esta posicin inicial */
			pos_inicio_del_arrastre = evento.GetPosition();
			#ifdef DEBUG_ON_RATON
				wxLogMessage ("Hallada figura en (%i, %i)", evento.GetPosition().x,
							evento.GetPosition().y );
			#endif
		}
		/*	Pero si se pulsa y no se encuentra una figura... */
		if ( evento.LeftIsDown() && 
			( (figura=BuscarElemento(evento.GetPosition()))==NULL ) )
		{
			#ifdef DEBUG_ON_RATON
				wxLogMessage ("Boton pulsado en (%i, %i)", evento.GetPosition().x,
							evento.GetPosition().y );
			#endif
			OnBotonPulsado (evento.GetPosition());
			ReiniciarEstado();
			return ;
		}
	} /* Fin del estado inicial */
	
	if ( estado_actual == EN_ESPERA )
	{
		/*	Si se suelta el boton...*/
		if (evento.LeftUp())
		{
			/*	...es porque se ha seleccionado una figura, y que
				quiz se vaya a conectar a otra ms adelante. Se debe
				seleccionar */
			ComprobarPuntero (elemento_emisor);
			elemento_emisor->Seleccionar();
			/* Se puede descomentar esto si se desea que se nos pida la salida
				inmediatamente, pero es bastante incomodo para el usuario
				(en mi opinion)*/
			//pos_salida_emisora = elemento_emisor->ElegirSalidaDeEmisor();
			estado_actual = EN_ELEM_SELECCIONADO ;
			
			/*	TODO: Quitar esta informacion de depuracion o
				enviarla a otro sitio */
			wxString inf=elemento_emisor->getInformacion();
			wxLogMessage(inf);
			
			wxClientDC contexto(this);
			Dibujar (contexto);
			return ; /*	Esto es necesario para esperar que 
						ocurra otro evento */
		} /* Fin de leftup*/
		/* Si se arrastra ... */
		if (evento.Dragging())
		{
			/* Se comprueba cuanto se ha movido...*/
			int tolerancia = 2;
	        int dx = abs(evento.GetPosition().x - pos_inicio_del_arrastre.x);
	        int dy = abs(evento.GetPosition().y - pos_inicio_del_arrastre.y);
	        /*	Si no se ha movido un mnimo...*/
	        if (dx <= tolerancia && dy <= tolerancia) 
			{
				/*...no hacemos nada */
            	return;
			}
			/*... pero si se ha movido bastante es porque el 
			usuario quiere arrastrar, as que se cambia de estado */
			estado_actual = EN_MOVIMIENTO;
			#ifdef DEBUG_ON_RATON
				wxLogMessage ("Iniciando el arrastre");
			#endif
			/*	El objeto que pareca que iba a ser un emisor va a ser
				arrastrado*/
			figura_en_arrastre = elemento_emisor ;
						
			imagen_de_arrastre = new wxGenericDragImage (
				figura_en_arrastre->GetBitmap() );
			#ifdef DEBUG_ON_RATON
				if (imagen_de_arrastre == NULL) wxLogMessage ("Imagen NULL!!");
			#endif
			/*	No queremos que se vea la figura en arrastre junto a la imagen
			de arrastre */
			figura_en_arrastre->SetVisible (false);
			wxClientDC contexto (this);
			contexto.Clear();
			Dibujar (contexto);
			/*	Se inicia el proceso Drag en WxWidgets */
			bool permiso_para_usar_pantalla_completa = false;
			
			wxPoint hotSpot = pos_inicio_del_arrastre - figura_en_arrastre->GetXY();
//			wxPoint hotSpot = figura_en_arrastre->GetXY();
			if (!imagen_de_arrastre->BeginDrag(hotSpot, 
				this, permiso_para_usar_pantalla_completa))
	        {
	            delete imagen_de_arrastre;
	            imagen_de_arrastre = NULL;
	        } 
	        else {
            	imagen_de_arrastre->Move(evento.GetPosition());
            	imagen_de_arrastre->Show();
        	} /* Fin del if begindrag */
			
		} /* Fin del if dragging */
	} /* Fin del estado en_espera */
	
	if ( estado_actual == EN_MOVIMIENTO )
	{
		if ( evento.LeftIsDown() )
		{
			imagen_de_arrastre->Move(evento.GetPosition());
		}
		/*	Cuando se suelta el botn */
		if ( evento.LeftUp() )
		{
			/*	Se acaba con el arrastre */
			#ifdef DEBUG_ON_RATON
				wxLogMessage ("Aqui acaba el arrastre");
			#endif
			imagen_de_arrastre->Hide();
			imagen_de_arrastre->EndDrag();
			delete imagen_de_arrastre;
			imagen_de_arrastre = NULL;
			wxPoint pos_click = evento.GetPosition();
			/*	Se controla que nadie arrastre nada fuera del rea */
			if (pos_click.x < 0)
			{
				pos_click.x=0;
			}
			if (pos_click.x > this->GetRect().width)
			{
				pos_click.x=this->GetRect().width;
			}
			if (pos_click.y < 0)
			{
				pos_click.y=0;
			}
			if (pos_click.y > this->GetRect().height)
			{
				pos_click.y=this->GetRect().height;
			}
			/*	Este recalculo se hace porque queremos trabajar situando
				iconos arrastrando desde el centro y no desde la esquina */
			int desplazamiento_x = ANCHURA_ICONOS / 2;
			int desplazamiento_y = ALTURA_ICONOS / 2;
			/*	La figura se pone en esa nueva posicin */
			figura_en_arrastre->SetXY ( pos_click.x - desplazamiento_x, 
						pos_click.y - desplazamiento_y );
			
			/*	Se redibuja todo */
			figura_en_arrastre->SetVisible (true);
			wxClientDC contexto(this);
			contexto.Clear();
			Dibujar (contexto);
			
			ReiniciarEstado();
			return ;
		}
	} /* Fin del estado en_movimiento */
	
	if ( estado_actual == EN_ELEM_SELECCIONADO )
	{
		/*	Si se hace click en un espacio vacio se deselecciona*/
		if ( evento.LeftDown() && 
			( (figura=BuscarElemento(evento.GetPosition()))==NULL ) )
		{
			#ifdef DEBUG_ON_RATON
				wxLogMessage ("Boton pulsado en (%i, %i)", evento.GetPosition().x,
							evento.GetPosition().y );
			#endif
			ReiniciarEstado();
			OnBotonPulsado (evento.GetPosition());
			return ; /* No queremos seguir examinando cosas */
		} /* Fin de la deseleccion */
		
		/*	Pero si se hace click... */
		/*	...sobre el mismo elemento...*/
	 	if ( evento.LeftDown() && 
			( (figura=BuscarElemento(evento.GetPosition()))==elemento_emisor ) )
		{
			/*	Se impide reiniciando el estado */
			#ifdef DEBUG_ON_RATON
				wxLogMessage ("No se puede unir un elemento a s mismo");
			#endif
			
			ReiniciarEstado();
			return ;
		} /* Fin del mismo elemento */
		
		if ( evento.LeftDown() && 
			( (figura=BuscarElemento(evento.GetPosition()))!=elemento_emisor ) )
		{
			/*	Se comprueba de nuevo que el emisor no sea null */
			if (elemento_emisor != NULL )
			{
				#ifdef DEBUG_ON_RATON
					wxLogMessage ("Elementos relacionados!");
				#endif
				
				elemento_receptor = figura ;
				
				if (figura !=NULL)
				{
					wxLogMessage ("Eligiendo entradas y salidas de elementos");
					pos_salida_emisora = elemento_emisor->ElegirSalidaDeEmisor();
					pos_entrada_receptora = figura->ElegirEntradaDeReceptor();
					ComprobarPuntero (elemento_emisor);
					ComprobarPuntero (elemento_receptor);
					
					/* Si el usuario no puls cancelar en ningn caso... */
					if ( (pos_salida_emisora!=ELECCION_CANCELADA) && 
						(pos_entrada_receptora!=ELECCION_CANCELADA)) {
							ConectarElementos (elemento_emisor, elemento_receptor,
								pos_salida_emisora, pos_entrada_receptora);
							}
//					elemento_emisor->anadirSuscriptor (elemento_receptor);
					ReiniciarEstado();
					return ;
				}
				else {
					wxLogMessage ("figura sera NULL");
				}
			}
		} /* Fin del mismo elemento */
	} /* Fin del estado elem_seleccionado */
} /*Fin de OnRaton */


/*	Se llama a este mtodo cuando se produce un evento de repintado de
	pantalla */
void Pagina::OnPaint( wxPaintEvent &WXUNUSED(evento) )
{
    wxPaintDC dc( this );
    PrepareDC( dc );
    //Dibujar (dc);
    Actualizar();
    /*	Se dibujan todas las figuras del sistema */
}

