#include "ventana.h"
#include "pagina.h"
#include "wx/memory.h"

/*	Fin de los includes */

/* 	Aqui se abrira un cuadro de dialogo que preguntara por el nombre
	del elemento a insertar */
ElementoVisual* Ventana::insertarObjetoEnSistema ( 
				int tipoDeElemento, wxWindow* ventana, int x, int y )
{
	/*	Dado que queremos que el raton se use para indicar
		el centro donde se va a dibujar el elemento, hay
		que calcular un desplazamiento. Este desplazamiento
		es la mitad de la anchura y de la altura */
	int desplazamiento_x = ANCHURA_ICONOS / 2;
	int desplazamiento_y = ALTURA_ICONOS / 2;
	ElementoVisual *elementoInsertado;
	
	/*	Damos un aviso en pantalla de que el elemento se ha insertado*/
//	texto->AppendText ( wxT ("Elemento insertado\n") );
	
	Pagina* paginaActiva =(Pagina*) ventana;
	
	/*	Si insertarElemento devuelve una referencia al elemento se
		podra configurar */
	elementoInsertado = paginaActiva->insertarElemento (
			tipoDeElemento, x-desplazamiento_x, y-desplazamiento_y);
	wxLogMessage ("Se ha insertado un elemento de tipo %i", tipoDeElemento);
	wxLogMessage (" en la posicion (%i, %i)", x, y);
	
	Sistema* sistema=paginaActiva->GetSistema();
	const char* nombreDelSistema = sistema->getNombreElemento();
	wxLogMessage (" en el sistema %s", nombreDelSistema);
	
//	#define DEBUG_ELEMENTOS
	#ifdef DEBUG_ELEMENTOS
		Ventana::TestElectroiman();
		TestTemporizador();
		TestPulsador();
		TestFotoSensor();
		TestContador();
		TestMotor();
		TestReed();
		TestBiestable();
		TestZumbador(); 
		TestRele();
		TestLampara();

	#else
		/* Si esta activa la autoconfiguracin */
		if (true)
		{
		}
		else {
			if (elementoInsertado==NULL)
			{
				wxMessageBox ("Se va a configurar un elemento NULL");
			}
			elementoInsertado->Configurar();
		}
	#endif	
		
	
	/*	Ya no hay nada activo */
	barraDeHerramientasEstaActiva 	= 	false;
	elementoActivo					=	NINGUNO;
	return elementoInsertado;	
}
