#include "ventana.h"

#include "dialogos/dialogopulsador.h"
#include "dialogos/dialogoelectroiman.h"
#include "dialogos/dialogotemporizador.h"
#include "dialogos/dialogofotosensor.h"
#include "dialogos/dialogocontador.h"
#include "dialogos/dialogomotor.h"
#include "dialogos/dialogoreed.h"
#include "dialogos/dialogobiestable.h"
#include "dialogos/dialogozumbador.h"
#include "dialogos/dialogorele.h"
#include "dialogos/dialogolampara.h"

/****************************METODOS DE PRUEBA***************************/
void Ventana::TestTemporizador()
{
	Voltaje* vEntradaReposo		=	new Voltaje (0.0);
	Voltaje* vSalidaReposo		=	new Voltaje (0.0);
	Voltaje* vEntradaActivacion	=	new Voltaje(0.0);
	Voltaje* vSalidaActivacion	=	new Voltaje(7.0);
	int 	 tiempo				=	21;
	
	Temporizador *t = new Temporizador (
		vEntradaReposo, vSalidaReposo, vEntradaActivacion, vSalidaActivacion,
		tiempo);
	t->setNombreElemento ("Temporizador de prueba");
	
	dialogoDeConfiguracion[TEMPORIZADOR]->getPropiedades (t);
	dialogoDeConfiguracion[TEMPORIZADOR]->ShowModal();
	
	
	dialogoDeConfiguracion[TEMPORIZADOR]->setPropiedades (t);
	dialogoDeConfiguracion[TEMPORIZADOR]->ShowModal();
	
}
void Ventana::TestElectroiman()
{
	Voltaje* vReposo		=	new Voltaje (0.0);
	Voltaje* vActivacion	=	new Voltaje(7.0);
	Magnetismo* mReposo		=	new Magnetismo (true);
	Magnetismo* mActivacion	=	new Magnetismo (true);
				
	/*Creamos el electroiman*/
	Electroiman* e			=	new Electroiman(vReposo, vActivacion,
		mReposo, mActivacion);
	e->setNombreElemento ("Electroiman de prueba");
	
	/*	Hacemos que el dialogo muestre el elemento*/
	dialogoDeConfiguracion[ELECTROIMAN]->getPropiedades (e);
	dialogoDeConfiguracion[ELECTROIMAN]->ShowModal();
	
	dialogoDeConfiguracion[ELECTROIMAN]->setPropiedades (e);
	dialogoDeConfiguracion[ELECTROIMAN]->ShowModal();

}

void Ventana::TestPulsador()
{

	Conexion* c1=new Conexion (CONEXION_INACTIVA);
	Conexion* c2=new Conexion (CONEXION_ACTIVA);
	Voltaje*  v1=new Voltaje  (0.0);
	Voltaje*  v2=new Voltaje  (5.0);
	
	Pulsador* p=new Pulsador(c1,v1,c2,v2);
	p->setNombreElemento ("Pulsador dialogante ;)");			
	/*	Hacemos que el dialogo muestre el elemento*/
	
	dialogoDeConfiguracion[PULSADOR]->getPropiedades (p);
	dialogoDeConfiguracion[PULSADOR]->ShowModal();
	
	dialogoDeConfiguracion[PULSADOR]->setPropiedades (p);
	dialogoDeConfiguracion[PULSADOR]->ShowModal();
}

void Ventana::TestFotoSensor()
{	
	Luminosidad* lReposo			=new Luminosidad ("OFF");
	Luminosidad* lActivacion		=new Luminosidad ("Magenta oscuro");
	Voltaje*	 vSalidaReposo		=new Voltaje (0.0);
	Voltaje*	 vSalidaActivacion	=new Voltaje (5.0);
	
	FotoSensor* fs=new FotoSensor (lReposo, lActivacion,
		vSalidaReposo, vSalidaActivacion);
		
	dialogoDeConfiguracion[FOTOSENSOR]->getPropiedades(fs);
	dialogoDeConfiguracion[FOTOSENSOR]->ShowModal();
	
	dialogoDeConfiguracion[FOTOSENSOR]->setPropiedades(fs);
	dialogoDeConfiguracion[FOTOSENSOR]->ShowModal();
	wxLogMessage (wxT("Se recuerda que en el fotosensor falta implementar \
		en getPropiedades y en setPropiedades el trasvase de activado y desactivado"));
}

void Ventana::TestContador()
{	
	Voltaje *v1=new Voltaje(0.0);
	Voltaje *v2=new Voltaje(5.0);
	int numPulsos=3;
	Contador *c=new Contador(numPulsos, v1,v2,v1,v2);
	
	Contador* c2=new Contador (numPulsos+10, v2, v1, v2, v1);
	c->setNombreElemento ("Contador del dialogo");
	dialogoDeConfiguracion[CONTADOR]->getPropiedades(c2);
	dialogoDeConfiguracion[CONTADOR]->ShowModal();
	
	dialogoDeConfiguracion[CONTADOR]->setPropiedades(c);
	dialogoDeConfiguracion[CONTADOR]->ShowModal();
	//wxLogMessage (wxT("Se recuerda que en el CONTADOR falta implementar"));
}

void Ventana::TestMotor()
{
	Voltaje*	vReposo	=	new Voltaje (0.0);
	Voltaje*	vGiroCW	=	new	Voltaje (7.0);
	Voltaje*	vGiroCCW=	new Voltaje (-3.0);

	Giro*	giroReposo	=	new Giro ("stop");
	Giro*	giroCW		= 	new Giro ("cw");
	Giro*	giroCCW		=	new Giro ("ccw");
	
	unsigned int rpm=1200;
	
	Motor* m=new Motor(vReposo,giroReposo,vGiroCW,giroCW,
		vGiroCCW, giroCCW, rpm);
		
	m->setNombreElemento ("Motor de prueba");	
	dialogoDeConfiguracion[MOTOR]->getPropiedades(m);
	dialogoDeConfiguracion[MOTOR]->ShowModal();
	dialogoDeConfiguracion[MOTOR]->setPropiedades(m);
	
	/*	Con estas dos lneas se fuerza el borrado */
	Motor* n=new Motor(vReposo,giroReposo,vGiroCW,giroCW,
		vGiroCCW, giroCCW, rpm);
	dialogoDeConfiguracion[MOTOR]->getPropiedades(n);
	
	dialogoDeConfiguracion[MOTOR]->getPropiedades(m);
	dialogoDeConfiguracion[MOTOR]->ShowModal();
	
}


void Ventana::TestReed()
{
	Magnetismo *m1=new Magnetismo(false);
	Magnetismo *m2=new Magnetismo(true);
	Voltaje*	v1=new Voltaje (0.0);
	Voltaje*	v2=new Voltaje (5.0);			
	
	Reed* r1=new Reed(m1,v1,m2,v2);
	
	
	dialogoDeConfiguracion[REED]->getPropiedades(r1);
	dialogoDeConfiguracion[REED]->ShowModal();
	dialogoDeConfiguracion[REED]->setPropiedades(r1);
	
	/*	Con estas dos lneas se fuerza el borrado */
	Reed* r2=new Reed(m2,v2,m1,v1);
	dialogoDeConfiguracion[REED]->getPropiedades(r2);
	
	/* Y se comprueba si se rescatan correctamente las propiedades */
	dialogoDeConfiguracion[REED]->getPropiedades(r1);
	dialogoDeConfiguracion[REED]->ShowModal();
	
}
void Ventana::TestBiestable()
{
	Voltaje*  activar1	=	new Voltaje (5.0);
	Voltaje*  desactivar1=	new Voltaje (0.0);
	Voltaje*  activar2	=	new Voltaje (5.0);
	Voltaje*  desactivar2=	new Voltaje (0.0);
	Voltaje*  activar3	=	new Voltaje (5.0);
	Voltaje*  desactivar3=	new Voltaje (0.0);
	Voltaje*  activar4	=	new Voltaje (5.0);
	Voltaje*  desactivar4=	new Voltaje (0.0);
	
	Biestable* b1=new Biestable(activar1, desactivar1, 
		activar2,desactivar2, activar3, desactivar3,
		activar4,desactivar4);
			
	dialogoDeConfiguracion[BIESTABLE]->getPropiedades(b1);
	dialogoDeConfiguracion[BIESTABLE]->ShowModal();
	dialogoDeConfiguracion[BIESTABLE]->setPropiedades(b1);
	
	/*	Con estas dos lneas se fuerza el borrado */
	Biestable* b2=new Biestable(desactivar1, activar1, 
		desactivar2,activar2, desactivar3, activar3,
		desactivar4,activar4);
	dialogoDeConfiguracion[BIESTABLE]->getPropiedades(b2);
	
	/* Y se comprueba si se rescatan correctamente las propiedades */
	dialogoDeConfiguracion[BIESTABLE]->getPropiedades(b1);
	dialogoDeConfiguracion[BIESTABLE]->ShowModal();
	
}

void Ventana::TestZumbador()
{
	Voltaje 	*vReposo	=	new Voltaje(0.0);
	Frecuencia	*fReposo	=	new Frecuencia (0);
	Voltaje		*vActivacion=	new Voltaje (5.0);
	Frecuencia	*fActivacion=	new	Frecuencia (3000);

	Zumbador *z1=new Zumbador (vReposo, fReposo, 
		vActivacion, fActivacion);
						
	dialogoDeConfiguracion[ZUMBADOR]->getPropiedades(z1);
	dialogoDeConfiguracion[ZUMBADOR]->ShowModal();
	dialogoDeConfiguracion[ZUMBADOR]->setPropiedades(z1);
	/*	Falta por codificar la recuperacion de la frecuencia! */
	Zumbador *z2=new Zumbador (	vActivacion, fActivacion,vReposo, fReposo );
	dialogoDeConfiguracion[ZUMBADOR]->getPropiedades(z2);
	
	/* Y se comprueba si se rescatan correctamente las propiedades */
	dialogoDeConfiguracion[ZUMBADOR]->getPropiedades(z1);
	dialogoDeConfiguracion[ZUMBADOR]->ShowModal();
	
}

void Ventana::TestRele()
{
	Conexion* c1=new Conexion (CONEXION_INACTIVA);
	Conexion* c2=new Conexion (CONEXION_ACTIVA);
	Voltaje*  v1=new Voltaje  (3.0);
	Voltaje*  v2=new Voltaje  (2.0);
	
	Rele *r1=new Rele (v1,c1,v2,c2);
						
	dialogoDeConfiguracion[RELE]->getPropiedades(r1);
	dialogoDeConfiguracion[RELE]->ShowModal();
	dialogoDeConfiguracion[RELE]->setPropiedades(r1);
	
	Rele *r2=new Rele (v2,c2,v1,c1);
	dialogoDeConfiguracion[RELE]->getPropiedades(r2);
	/* Y se comprueba si se rescatan correctamente las propiedades */
	dialogoDeConfiguracion[RELE]->getPropiedades(r1);
	dialogoDeConfiguracion[RELE]->ShowModal();
	
}

void Ventana::TestLampara()
{
	Voltaje*	v1=new Voltaje (0.0);
	Voltaje*	v2=new Voltaje (5.0);
	Luminosidad*l1=new Luminosidad("000000");
	Luminosidad*l2=new Luminosidad("44ff44");
	
	Lampara* lamp1=new Lampara(v1,l1,v2,l2);
									
	dialogoDeConfiguracion[LAMPARA]->getPropiedades(lamp1);
	dialogoDeConfiguracion[LAMPARA]->ShowModal();
	dialogoDeConfiguracion[LAMPARA]->setPropiedades(lamp1);
	
	Lampara* lamp2=new Lampara(v2,l2,v1,l1);
	dialogoDeConfiguracion[LAMPARA]->getPropiedades(lamp2);
	/* Y se comprueba si se rescatan correctamente las propiedades */
	dialogoDeConfiguracion[LAMPARA]->getPropiedades(lamp1);
	dialogoDeConfiguracion[LAMPARA]->ShowModal();
	
}

