#include <cstdlib>
#include <iostream>
#include "sistema.h"
#include "pulsador.h"
#include "lampara.h"
#include "fotosensor.h"
#include "contador.h"
#include "biestable.h"

using namespace std;

Pulsador* obtenerPulsador()
{
				/*	Creamos un pulsador que si no esta activado emite 0.0V
				y que si esta activado emite 5.0V */
			Conexion* c1=new Conexion (CONEXION_INACTIVA);	
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  v1=new Voltaje  (0.0);
			Voltaje*  v2=new Voltaje  (5.0);
			
			Pulsador* p1=new Pulsador (c1,v1,c2,v2);
			p1->setNombreElemento ("Pulsador1");
			
			return p1;
}
Lampara* obtenerLampara()
{
			Voltaje*  v1=new Voltaje  (0.0);
			Voltaje*  v2=new Voltaje  (5.0);

			Luminosidad* l1=new Luminosidad ("NEGRO");
			Luminosidad* l2=new Luminosidad ("VERDE");
			
			Lampara* lamp=new Lampara(v1,l1,v2,l2);
			
			return lamp;
}
Biestable* obtenerBiestable()
{
			Voltaje*  activar1	=	new Voltaje (5.0);
			Voltaje*  desactivar1=	new Voltaje (0.0);
			Voltaje*  activar2	=	new Voltaje (5.0);
			Voltaje*  desactivar2=	new Voltaje (0.0);
			Voltaje*  activar3	=	new Voltaje (5.0);
			Voltaje*  desactivar3=	new Voltaje (0.0);
			Voltaje*  activar4	=	new Voltaje (5.0);
			Voltaje*  desactivar4=	new Voltaje (0.0);
			
			Biestable* b1=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			return b1;
}

FotoSensor* obtenerFotosensor()
{
			/*	Ahora creamos un fotosensor sensible al verde */
			Luminosidad* lReposo			=new Luminosidad ("NEGRO");
			Luminosidad* lActivacion		=new Luminosidad ("VERDE");
			Voltaje*	 vSalidaReposo		=new Voltaje (0.0);
			Voltaje*	 vSalidaActivacion	=new Voltaje (5.0);
			FotoSensor* fs=new FotoSensor (lReposo, lActivacion,
				vSalidaReposo, vSalidaActivacion);
			return fs;
}
void imprimir(Elemento* e)
{
	Senal* entrada=e->getEntradaPorPosicion();
	Senal* salida=e->getSalidaPorPosicion();
	const char* nombre=e->getNombreElemento();
	printf ("Elemento %s\n", nombre);
	printf ("\t Senal de entrada: %s\n", entrada->toString());
	printf ("\t Senal de salida: %s\n", salida->toString());
}
void PruebaSistemaSimple()
		{
			Pulsador* p1=obtenerPulsador();
			p1->setNombreElemento ("Pulsador1");
			/*	Creamos una lampara que cuando recibe 0.0V est en negro
				y cuando recibe 5.0V esta VERDE */
			
			Lampara* lamp = obtenerLampara();
			lamp->setNombreElemento("Lampara1");
			
			/*	Hacemos que la lampara "escuche" al pulsador convirtiendose
				en suscriptor de dicho pulsador */
			int codigo_error=p1->anadirSuscriptor (lamp);
			
			
			Biestable* b1=obtenerBiestable();
			b1->setNombreElemento("Biestable");
						
			/*	Hasta aqui llega el cortado y copiado, ahora estos 
				elementos se aaden al sistema*/
			Sistema* s=new Sistema();
			s->anadirElemento(p1);
			s->anadirElemento(lamp);
			s->anadirElemento(b1);
			/*	Probamos a modificar la entrada del pulsador*/
			Conexion* c2=new Conexion (true);
			s->setEntrada(c2, "Pulsador1");
			printf ("Pulsador modificado\n");
			Elemento* ee=s->getRefElementoPorNombre ("Pulsador1");
			imprimir (p1);
			
			int entradapulsador=s->getEntradaDeSistema ("Pulsador1");
			printf ("La entrada al pulsador en s es %i\n", entradapulsador);
			
			int salidapulsador = s->getSalidaDeSistema ("Pulsador1");
			printf ("La salida al pulsador en s es %i\n", salidapulsador);
			
			int entradalampara=s->getEntradaDeSistema ("Lampara1");
			printf ("La entrada a lampara en s es %i\n", entradalampara);
			
			int salidalampara = s->getSalidaDeSistema ("Lampara1");
			printf ("La salida al lampara en s es %i\n", salidalampara);
			
			Sistema* sgrande=new Sistema();
			sgrande->anadirElemento(s);
			
			Senal* entradaR=sgrande->getEntradaPorNombreYPosicion("Biestable", POS_ENTRADA);
			printf ("La seal de entrada R al biestable es %s\n", 
				entradaR->toString());
			Senal* entradaS=sgrande->getEntradaPorNombreYPosicion("Biestable", POS_ENTRADA+1);
			printf ("La seal de entrada S al biestable es %s\n", 
				entradaS->toString());
			Senal* entradaQ=sgrande->getSalidaPorNombreYPosicion("Biestable", POS_SALIDA);
			printf ("La seal de salida Q al biestable es %s\n", 
				entradaQ->toString());
			Senal* entradaQneg=sgrande->getSalidaPorNombreYPosicion("Biestable", POS_SALIDA+1);
			printf ("La seal de salida Qneg al biestable es %s\n", 
				entradaQneg->toString());
		}
		
		/*	En este test se va a meter un sistema dentro de otro
			El sistema S1 contiene un pulsador conectado a una lampara
			El sistema S2 contiene un fotosensor
			El sistema Sgrande contendra a S1 y S2*/
		void PruebaSistemaRecursivo()
		{
			Pulsador* p1=obtenerPulsador();			
			p1->setNombreElemento ("Pulsador1");
			
			Lampara* lamp = obtenerLampara();
			lamp->setNombreElemento("Lampara1");
			
			p1->anadirSuscriptor(lamp);
			printf ("\n\n----Depurando el sistema recursivo\n\n\n");
			Sistema* S1=new Sistema();
			S1->setNombreElemento ("Sistema S1");
			S1->anadirElemento(p1);
			S1->anadirElemento(lamp);
			
			/*	Antes de hacer comprobaciones comprobamos cuantas
				entradas y salidas tiene el sistema S1. Hay 12 entradas
				debido a las 4 originales del sistema mas las 4 del
				pulsador mas las 4 de la lampara*/
			int totalEntradas=S1->getTotalEntradas();
			//assert_eq ("Entradas totales de S1", 12, totalEntradas);
			
			/* En total esta la salida del sistema mas las 2 de los elementos*/
			int totalSalidas=S1->getTotalSalidas();
			//assert_eq ("Salidas totales de S1", 3, totalSalidas);
			
			/*	Comprobamos las posiciones de las entradas de p1
				(que tiene 4 entradas (del 0 al 3) para POS_ENABLE,
				POS_KEEP, POS_RESET y entrada), sin embargo el sistema
				tiene las 4 primeras entradas para sus propias entradas
				asi que la primera debe ser 4*/
				
			int primeraEntradaDelPulsador=S1->getPrimeraEntrada("Pulsador1");
			//assert_eq ("Primera entrada P1", 4, primeraEntradaDelPulsador);
			
			/*	Las siguientes entradas seran de la 4 a 7*/
			int primeraEntradaDeLampara=S1->getPrimeraEntrada("Lampara1");
			//assert_eq ("Primera entrada L1", 8, primeraEntradaDeLampara);
			
			int primeraSalidaPulsador=S1->getPrimeraSalida("Pulsador1");
			//assert_eq ("Primera salida p1", 1, primeraSalidaPulsador);
			
			int primeraSalidaLampara=S1->getPrimeraSalida("Lampara1");
			//assert_eq ("Primera salida l1", 2, primeraSalidaLampara);
			
			FotoSensor* fs=obtenerFotosensor();			
			fs->setNombreElemento ("FotoSensor1");
			Sistema *S2=new Sistema();
			S2->setNombreElemento ("Sistema S2");
			S2->anadirElemento(fs);
			
			/*	Ahora viene lo importante:
				Vamos a obtener la primera salida del sistema S1 que
				se refiera a Lampara1 y la vamos a conectar a la
				primera entrada del sistema S2 que se refiera al
				Fotosensor1. Asi podremos comprobar si podemos
				tratar los sistemas como cajas negras simplemente
				conectando las entradas a las salidas*/
			
			int posSalidaLampara     = S1->getPrimeraSalidaUtil("Lampara1");
			int posEntradaFotosensor = S2->getPrimeraEntradaUtil ("FotoSensor1");
			#define DEBUG_SISTEMA
			#ifdef DEBUG_SISTEMA
			printf ("Salida lamp1 en S1:%i\tEntrada Fs1 en S2:%i\n",
				posSalidaLampara, posEntradaFotosensor);
			#endif
		
			S1->anadirSuscriptor(S2, posEntradaFotosensor, 
				posSalidaLampara);
			
			#ifdef DEBUG
			printf ("Sistema S2 es suscriptor de S1\n");
			#endif
			/*	Vamos a intentar modificar la entrada de S1 para activar
				el pulsador que lleva dentro*/
			
			int posEntradaPulsador = S1->getPrimeraEntradaUtil ("Pulsador1");
//			printf ("La primera entrada del pulsador es %i\n", posEntradaPulsador);
			
			
			
			/*	Si metemos un voltaje de 5V en esa entrada se activa el
				fotosensor que estaba en el sistema S2?*/
			Conexion *entrada=new Conexion(CONEXION_ACTIVA);
			
			
			/*
				Aqui falla todo, el conector de salida de la
				la lampara no recibe la seal correcta */
			S1->setEntrada(entrada,posEntradaPulsador);
			Luminosidad* resultado= 
				(Luminosidad* )S1->getSalidaPorNombre("Lampara1");
			printf ("La lampara tiene %s\n",resultado->toString() );
			int comparacion=strcmp("VERDE", resultado->getValor() );
			/*assert_eq ("Conexion correcta (por interfaz)",
				 0, comparacion);*/
			
			#ifdef DEBUG_SISTEMA
			printf ("\n\n----Prueba refinitiva---\n\n");
			#endif
			int posSalidaFotoSensor=S2->getPrimeraSalida ("FotoSensor1");
			printf ("En S2 el fotoSensor1 tiene la salida %i\n",
						posSalidaFotoSensor);
			
			/*Otra comprobacion rutinaria*/
			Voltaje* prueba=(Voltaje*)fs->getSalidaPorPosicion();
			printf ("El voltaje obtenido es %f\n",prueba->getValor());
			Voltaje *salidaFotoSensor=(Voltaje*) S2->getSalidaPorPosicion(
											posSalidaFotoSensor);
			bool esVoltNulo=(salidaFotoSensor==NULL);
			printf ("El voltaje por posicion es %f\n",
				salidaFotoSensor->getValor() );
				
			Senal* entradaFotoSensor = S2->getEntradaPorPosicion(3);
			printf ("La entrada al fotosensor es %s\n", entradaFotoSensor->toString());
			
			Senal* salidaS1 = S1->getSalidaPorPosicion (1);
			printf ("La salida de la lampara en S1 es %s\n", salidaS1->toString());
			//assert_eq ("Voltaje no localizado", false, esVoltNulo);
			/*assert_eq ("Voltaje de salida del fotosensor en S2",
				5.0, salidaFotoSensor->getValor() );*/
		}
			void PruebaAnadido()
		{
			/*	Creamos un pulsador que si no esta activado emite 0.0V
			y que si esta activado emite 5.0V */
			Conexion* c1=new Conexion (CONEXION_INACTIVA);	
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  v1=new Voltaje  (0.0);
			Voltaje*  v2=new Voltaje  (5.0);
			
			Pulsador* p1=new Pulsador (c1,v1,c2,v2);
			p1->setNombreElemento ("Pulsador1");
			
			Voltaje *vv1=new Voltaje(0.0);
			Voltaje *vv2=new Voltaje(5.0);
			Voltaje *vvv1=new Voltaje(0.0);
			Voltaje *vvv2=new Voltaje(5.0);
			int numPulsos=1;

			Contador *c=new Contador(numPulsos, vv1,vv2,vvv1,vvv2);
			c->setNombreElemento ("Contador1");
			/*	Se va a crear un sistema principal con un pulsador y un 
				subsistema */
			Sistema* sist_principal=new Sistema();
			Sistema* subsistema=new Sistema();
			subsistema->setNombreElemento("Subsistema");
			sist_principal->anadirElemento(p1);
			sist_principal->anadirElemento(subsistema);
			
			/*Se crea un subsubsistema que ir dentro de subsistema*/
			Sistema* subsubsistema=new Sistema();
			subsubsistema->setNombreElemento("Subsubsistema");
			subsistema->anadirElemento(subsubsistema);
			
			/*Y el contador va dentro del subsubsistema*/
			subsubsistema->anadirElemento (c);
			
//			subsubsistema->destruirElemento (c);
			sist_principal->destruirElemento(subsistema);
		}
		void pruebaEliminacionCompleja()
		{
			Voltaje *v1=new Voltaje(0.0);
			Voltaje *v2=new Voltaje(5.0);
			int numPulsos=3;
			Contador *c=new Contador(numPulsos, v1,v2,v1,v2);
			c->setNombreElemento("Contador 1");
			Sistema* subsubsistema=new Sistema();
			
			subsubsistema->anadirElemento(c);
			subsubsistema->setNombreElemento ("Subsubsistema");
			Elemento* recuperado=
				subsubsistema->getRefElementoPorNombre("Contador 1");
//			assert_eq ("Contador dentro de subsubsistema", c, recuperado);
			
			Voltaje*  activar1	=	new Voltaje (5.0);
			Voltaje*  desactivar1=	new Voltaje (0.0);
			Voltaje*  activar2	=	new Voltaje (5.0);
			Voltaje*  desactivar2=	new Voltaje (0.0);
			Voltaje*  activar3	=	new Voltaje (5.0);
			Voltaje*  desactivar3=	new Voltaje (0.0);
			Voltaje*  activar4	=	new Voltaje (5.0);
			Voltaje*  desactivar4=	new Voltaje (0.0);
			
			Biestable* b=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			b->setNombreElemento("Biestable 1");
			Sistema* subsistema=new Sistema();
			subsistema->anadirElemento(b);
			subsistema->anadirElemento(subsubsistema);
			subsistema->setNombreElemento("Subsistema");
			Elemento* recuperado2=
				subsistema->getRefElementoPorNombre("Biestable 1");
//			assert_eq ("Biestable dentro de subsistema", b, recuperado2);
			
			Conexion* c1=new Conexion (CONEXION_INACTIVA);
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			
			Pulsador* p=new Pulsador(c1,v1,c2,v2);
			Sistema* sistema=new Sistema();
			p->setNombreElemento("Pulsador 1");
			sistema->anadirElemento(p);
			sistema->anadirElemento(subsistema);
			sistema->setNombreElemento ("Sistema");
			Elemento* recuperado3=
				sistema->getRefElementoPorNombre("Pulsador 1");
//			assert_eq ("Pulsador dentro de sistema", p, recuperado3);
			
			/*	Tenemos un subsubsistema con un contador dentro.
				Ese subsubsistema est dentro de un subsistema
				junto con un biestable.
				Ese subsistema est dentro de un sistema junto
				con un pulsador. Todo como si fuera una mueca rusa.
				Ahora se conectan el biestable al contador */
			int entradacontador=subsubsistema->getPrimeraEntradaUtil
				("Contador 1");
			printf ("La entrada al contador en el subsubsistema es %i\n",
				entradacontador);
			/* Si es menor que 0 es que no se ha encontrador */
			bool encontrado = !(entradacontador<0);
//			assert_eq ("Contador 1 encontrado en subsubsistema",
//				true, encontrado);
			b->anadirSuscriptor(subsubsistema, entradacontador);
			
			int entradabiestable = subsistema->getPrimeraEntradaUtil
				("Biestable 1");
			printf ("La entrada al biestable en el subsistema es %i\n",
				entradabiestable);
			entradacontador=subsistema->getPrimeraEntradaUtil
				("Contador 1");
			printf ("La entrada al contador en el subsistema es %i\n",
				entradacontador);

			/*	La entradabiestable+1 es la entrada S*/
			p->anadirSuscriptor(subsistema, entradabiestable+1);
			
			/*	Activamos el pulsador */
			p->setEntrada(new Conexion(true));
			
			/*	Y se comprueba la salida */
			Voltaje* salidaBiestable= (Voltaje*)b->getSalidaPorPosicion();
			float valor= salidaBiestable->getValor();
//			assert_eq ("Salida biestable", 5.0, valor);
			
			/*	Aqui viene toda la chicha de este test.
				Se borra el biestable y se vuelve a pulsar
				el pulsador, para ver qu pasa */
			
			int poscont=subsubsistema->getPrimeraEntradaUtil("Contador 1");
			printf ("En el subsubsistema la Entrada del contador es %i\n", poscont);
			
			poscont=subsubsistema->getPrimeraSalidaUtil("Contador 1");
			printf ("En el subsubsistema la salida del contador es %i\n", poscont);
			
			
			poscont=subsistema->getPrimeraEntradaUtil("Contador 1");
			printf ("En el subsistema la Entrada del contador es %i\n", poscont);
			
			poscont=subsistema->getPrimeraSalidaUtil("Contador 1");
			printf ("En el subsistema la salida del contador es %i\n", poscont);
			
			poscont=sistema->getPrimeraEntradaUtil("Contador 1");
			printf ("En el sistema la Entrada del contador es %i\n", poscont);
			
			poscont=sistema->getPrimeraSalidaUtil("Contador 1");
			printf ("En el sistema la salida del contador es %i\n", poscont);
			
			int posbiestable = subsistema->getEntradaDeSistema ("Biestable 1", 
				POS_ENTRADA+1);
			printf ("El pulsador envia su salida a sistema(biestable) pos %i\n",
				posbiestable);
			p->anadirSuscriptor (subsistema, posbiestable);
			
			poscont = subsubsistema->getEntradaDeSistema ("Contador 1");
			b->anadirSuscriptor (subsubsistema, poscont);
			p->setEntrada (new Conexion(true));
			
			subsistema->eliminarElemento(b);
			/*	Reinicio el estado del biestable*/
			b->setEntrada(new Voltaje(0.0));
			
			/*	Se pulsa el pulsador otra vez */
			p->setEntrada(new Conexion(false));
			
			/*	Esto debe fallar*/
			salidaBiestable= (Voltaje*)b->getSalidaPorPosicion();
			printf ("Recuperada la salida del biestable...");
			valor= salidaBiestable->getValor();
			printf ("...hecho\n");
//			assert_eq ("Salida biestable", 5.0, valor);
		}
		
		void prueba()
		{
			Voltaje*  activar1	=	new Voltaje (5.0);
			Voltaje*  desactivar1=	new Voltaje (0.0);
			Voltaje*  activar2	=	new Voltaje (5.0);
			Voltaje*  desactivar2=	new Voltaje (0.0);
			Voltaje*  activar3	=	new Voltaje (5.0);
			Voltaje*  desactivar3=	new Voltaje (0.0);
			Voltaje*  activar4	=	new Voltaje (5.0);
			Voltaje*  desactivar4=	new Voltaje (0.0);
			
			Biestable* b=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			b->setNombreElemento("Biestable 1");
			Sistema* subsistema=new Sistema();
			Sistema* sistema = new Sistema();
			subsistema->anadirElemento(b);
			int p1=subsistema->getPrimeraEntradaUtil("Biestable 1");
			printf ("p1 es %i\n", p1);
			
			int p2=subsistema->getEntradaDeSistema("Biestable 1", POS_ENTRADA);
			printf ("p2 es %i\n", p2);
			int p3=subsistema->getEntradaDeSistema("Biestable 1", POS_ENTRADA+1);
			printf ("p3 es %i\n", p3);
			
			int tipoEntrada = subsistema->getTipoEntrada(p2);
			printf ("El tipo de la entrada p3 es %i\n", tipoEntrada);
			
			sistema->anadirElemento(subsistema);
			subsistema->eliminarElemento(b);
			b=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			b->setNombreElemento("Biestable 2");
			sistema->anadirElemento(subsistema);
			subsistema->anadirElemento(b);			
			/* ALGO parece fallar aqui */
			int i = sistema->getEntradaDeSistema ("Biestable 2", POS_ENTRADA+1);
//			int i = sistema->getPrimeraEntradaUtil ("Biestable 1");
			printf ("El b esta en la posicion %i de sistema\n", i);
			sistema->setEntrada (new Voltaje(5.0), i);			
			Senal* entrada = sistema->getEntradaPorPosicion(i);
			printf ("El valor entrada es %s\n", entrada->toString());
			
			p3=subsistema->getSalidaDeSistema("Biestable 2");
			Senal* salida = subsistema->getSalidaPorPosicion(p3);
			salida = subsistema->getSalidaPorPosicion(p3);
			printf ("El valor de salida es %s\n", entrada->toString());
			
			/*	TODO: Poner a 0 la entrada S y comprobar */
			subsistema->setEntrada(new Voltaje(0.0),
				"Biestable 2", POS_ENTRADA+1);
			subsistema->setEntrada(new Voltaje(5.0),
				"Biestable 2", POS_ENTRADA);
			p3=subsistema->getSalidaDeSistema("Biestable 2");
			salida = subsistema->getSalidaPorPosicion(p3);
			printf ("El valor de salida es %s\n", salida->toString());
			
			subsistema->setEntrada(new Voltaje(0.0),
				"Biestable 9", POS_ENTRADA+1);
			int e=subsistema->getEntradaDeSistema("Biestable 2");
			subsistema->setEntrada(new Voltaje(5.0),e);
			salida = subsistema->getSalidaPorPosicion(p3);
			printf ("El valor de salida es %s\n", salida->toString());
			
			/*Comprobado */
			subsistema->eliminarElemento(b);
			sistema->anadirElemento(subsistema);
		}
		void pruebaInformacionElemento()
		{
			Sistema* s=new Sistema();
				
				
			Conexion* c1=new Conexion (CONEXION_INACTIVA);	
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  v1=new Voltaje  (0.0);
			Voltaje*  v2=new Voltaje  (5.0);
			
			Pulsador* p1=new Pulsador (c1,v1,c2,v2);
			p1->setNombreElemento ("Pulsador1");
						
			Voltaje*  activar1	=	new Voltaje (5.0);
			Voltaje*  desactivar1=	new Voltaje (0.0);
			Voltaje*  activar2	=	new Voltaje (5.0);
			Voltaje*  desactivar2=	new Voltaje (0.0);
			Voltaje*  activar3	=	new Voltaje (5.0);
			Voltaje*  desactivar3=	new Voltaje (0.0);
			Voltaje*  activar4	=	new Voltaje (5.0);
			Voltaje*  desactivar4=	new Voltaje (0.0);
			
			Biestable* b1=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			Biestable* b2=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			Biestable* b3=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			
			b1->setNombreElemento("B1");
			b2->setNombreElemento("B2");
			b3->setNombreElemento("B3");
			b1->anadirSuscriptor(b2);
			b2->anadirSuscriptor(b3);
			
			
			s->anadirElemento(b1);
			s->anadirElemento(b2);
			s->anadirElemento(b3);
			s->anadirElemento(p1);
			
			string infb2=b2->getInformacionElemento();
			cout << infb2;
			b2->eliminarSuscriptor(b3);
			printf ("Se ha eliminado el suscriptor b3 y ahora...\n");
			infb2=b2->getInformacionElemento();
			cout << infb2;
			
			p1->setEntrada(c2);
			Senal* entradaB2=s->getEntradaPorNombre ("Pulsador1");
			if (entradaB2==NULL)
			{
				printf ("Entrada Pulsador 1 es null\n");
			}
			else {
				printf ("La seal de entrada de pulsador 1 es %s\n", 
				entradaB2->toString());
			}
			
			b2->setEntrada(activar1, POS_ENTRADA+1);
			entradaB2=s->getEntradaPorNombreYPosicion ("B2", POS_ENTRADA+1);
			if (entradaB2==NULL)
			{
				printf ("Entrada B2 es null\n");
			}
			else {
				printf ("La seal de entrada de B2 es %s\n", 
				entradaB2->toString());
			}
			entradaB2=s->getEntradaPorNombreYPosicion ("B2", POS_ENTRADA);
			if (entradaB2==NULL)
			{
				printf ("Entrada B2 es null\n");
			}
			else {
				printf ("La seal de entrada de B2 es %s\n", 
				entradaB2->toString());
			}
			entradaB2=s->getEntradaPorNombreYPosicion ("Pulsador1", POS_ENTRADA);
			if (entradaB2==NULL)
			{
				printf ("Entrada B2 es null\n");
			}
			else {
				printf ("La seal de entrada de B2 es %s\n", 
				entradaB2->toString());
			}
			entradaB2=s->getSalidaPorNombreYPosicion ("Pulsador1", POS_SALIDA);
			if (entradaB2==NULL)
			{
				printf ("Entrada B2 es null\n");
			}
			else {
				printf ("La seal de entrada de B2 es %s\n", 
				entradaB2->toString());
			}
			
			activar1	=	new Voltaje (5.0);
			desactivar1=	new Voltaje (0.0);
			activar2	=	new Voltaje (5.0);
			desactivar2=	new Voltaje (0.0);
			activar3	=	new Voltaje (5.0);
			desactivar3=	new Voltaje (0.0);
			activar4	=	new Voltaje (5.0);
			desactivar4=	new Voltaje (0.0);
			
			Biestable* b=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
				
			b->setNombreElemento("Biestable");
			s->anadirElemento(b);			
		}
		
			void PruebaDestruccion()
		{
			Conexion* c1=new Conexion (CONEXION_INACTIVA);
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  v1=new Voltaje  (0.0);
			Voltaje*  v2=new Voltaje  (5.0);
			Pulsador* p;
			p=new Pulsador (c1,v1,c2,v2);			
			Voltaje*  activar1	=	new Voltaje (3.2);
			Voltaje*  desactivar1=	new Voltaje (0.0);
			Voltaje*  activar2	=	new Voltaje (3.2);
			Voltaje*  desactivar2=	new Voltaje (0.0);
			Voltaje*  activar3	=	new Voltaje (3.2);
			Voltaje*  desactivar3=	new Voltaje (0.0);
			Voltaje*  activar4	=	new Voltaje (3.2);
			Voltaje*  desactivar4=	new Voltaje (0.0);
			
			Biestable* b=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			
			Biestable* b2=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			b->setNombreElemento("El biestable intermedio");
			p->setNombreElemento ("El pulsador inicial");
			b2->setNombreElemento ("El biestable final");
			
			Sistema* s=new Sistema();
			s->setNombreElemento("Autodestructor");
			s->anadirElemento(p);
			
			s->anadirElemento(b);
			s->anadirElemento(b2);
			p->anadirSuscriptor(b);
			b->anadirSuscriptor(b2);
			const char* xml = s->getCadenaXML();
			printf ("La cadena XML es:\n%s\n", xml);
			
			s->eliminarElemento (b);
			int numElementos=s->numElementos();
			printf ("Ahora hay %i\n", numElementos);
			delete s;
		}
int main(int argc, char *argv[])
{
//    PruebaSistemaSimple();
//    PruebaSistemaRecursivo();
//    PruebaAnadido();
//
//	pruebaEliminacionCompleja();
//	prueba();
//pruebaInformacionElemento();

	PruebaDestruccion();

}
