#include "zumbador.h"


Zumbador::Zumbador (Voltaje* voltReposo, Frecuencia* frecReposo,
			Voltaje* voltActivacion, Frecuencia* frecActivacion)
{
	voltajeReposo			=	voltReposo;
	frecuenciaReposo		=	frecReposo;
	voltajeActivacion		=	voltActivacion;
	frecuenciaActivacion	=	frecActivacion;	
	entradas[POS_ENTRADA]	=	voltReposo;
	salidas [POS_SALIDA]	=	frecReposo;
}

Voltaje* Zumbador::getVoltajeReposo()
{
	return voltajeReposo;
}

Voltaje* Zumbador::getVoltajeActivacion()
{
	return voltajeActivacion;
}

Frecuencia*	Zumbador::getFrecuenciaReposo()
{
	return frecuenciaReposo;
}

Frecuencia*	Zumbador::getFrecuenciaActivacion()
{
	return frecuenciaActivacion;
}

Frecuencia*	Zumbador::getFrecuencia()
{
	return frecuenciaActivacion;;
}

int Zumbador::setEntrada (Senal* s, int posicion)
{
	Voltaje* vEntrada=(Voltaje*) s;
	
	if (vEntrada->getValor()==voltajeReposo->getValor() )
	{
		entradas[POS_ENTRADA]=vEntrada;
		salidas [POS_SALIDA] =frecuenciaReposo;
		return (Elemento::setEntrada(s, posicion));
	}
	if (vEntrada->getValor()==voltajeActivacion->getValor() )
	{
		entradas[POS_ENTRADA]=vEntrada;
		salidas [POS_SALIDA] =frecuenciaActivacion;
		return (Elemento::setEntrada(s, posicion));
	}
	
	/*	La entrada no pertenece a ningun caso conocido*/
	entradas[POS_ENTRADA]=vEntrada;
	return (Elemento::setEntrada(s,posicion));
}

NodoXML Zumbador::getXML ( DOMImplementation *impl )
{
	//etqElemento se hereda por parte de XMLSerializable	
	//etqElemento = XMLString::transcode ( "zumbador" );
	
	DOMDocument* doc = impl->createDocument ();
	doc = getDocumentoXMLBase ( doc, "zumbador", nombreElemento, x, y );
	
	/*	Ahora aadimos a doc los elementos XML para indicar las distintas
		caractersticas. No se debe alterar el orden de creacin de elementos
		ya que el esquema exige dicho orden */
	
	anadirElementoXML (doc, "entradareposo",	
								getVoltajeReposo()				);
	anadirElementoXML (doc, "salidareposo",		
								getFrecuenciaReposo() 			);
	anadirElementoXML (doc, "entradaactivacion",	
								getVoltajeActivacion()			);
	anadirElementoXML (doc, "salidaactivacion",		
								getFrecuenciaActivacion()		);


	DOMDocumentFragment* fragmento = doc->createDocumentFragment ();
	fragmento->appendChild ( doc->getDocumentElement() );
	return fragmento;
}


void Zumbador::construir (DOMElement* nodo)
{
	obtenerDatosComunes (nodo);
	/* Obtenemos los valores de los distintos nodos */
	
	voltajeReposo 		= (Voltaje*) getSenal 
							( VOLTAJE, 	"entradareposo", nodo);
							
	voltajeActivacion 	= (Voltaje*) getSenal 
							( VOLTAJE, "entradaactivacion", nodo);
	
	frecuenciaReposo	= (Frecuencia*) getSenal
							( FRECUENCIA, "salidareposo", nodo);
	frecuenciaActivacion= (Frecuencia*) getSenal
							( FRECUENCIA, "salidaactivacion", nodo);
	#ifdef DEBUG_ZUMBADOR
	printf ("Voltaje reposo:%s Voltaje activacion:%s", voltajeReposo->toString(),
		voltajeActivacion->toString() );
	printf ("Frec reposo:%s Frec activacion:%s\n", frecuenciaReposo->toString(),
			frecuenciaActivacion->toString() );
	#endif
	
	entradas[POS_ENTRADA]	=voltajeReposo;
	salidas[POS_SALIDA]		=frecuenciaReposo;
}
