#include "unit++.h"
#include "biestable.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	class PruebaParser : public suite
	{
		void pruebaParseadoPulsador()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			
			/* 	Se comprueba primero un fichero con un 
				sistema simple que contiene un nico pulsador*/
				
			ficheroCorrecto	=	p->esValido ("xml\\pulsador.xml");
			assert_eq ("Fichero pulsador XML correcto",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoErroneo()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Este es un fichero creado intencionadamente
				mal, para comprobar que el parser no falla
				y se "traga" todo */				
			ficheroCorrecto	=	p->esValido 
				("xml\\ficheroerroneo.xml");
			assert_eq ("Fichero XML erroneo",
				false, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoMotor()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\motor.xml");
			assert_eq ("Fichero motor XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoReed()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\reed.xml");
			assert_eq ("Fichero reed XML erroneo",
				true, ficheroCorrecto);
				
			delete p;
		}
		void pruebaParseadoRele()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\rele.xml");
			assert_eq ("Fichero rele XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoContador()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\contador.xml");
			assert_eq ("Fichero contador XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoTemporizador()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\temporizador.xml");
			assert_eq ("Fichero temporizador XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoBiestable()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\biestable.xml");
			assert_eq ("Fichero biestable XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoVector()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\vector.xml");
			assert_eq ("Fichero vector XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoRelacion()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\relacion.xml");
			assert_eq ("Fichero relacion XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoZumbador()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\zumbador.xml");
			assert_eq ("Fichero zumbador XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
		void pruebaParseadoElectroiman()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			/* 	Ejemplo sencillo de un sistema con 
				solo un motor */
			ficheroCorrecto	=	p->esValido 
				("xml\\electroiman.xml");
			assert_eq ("Fichero electroiman XML erroneo",
				true, ficheroCorrecto);
			delete p;
		}
	public:
		PruebaParser(): suite ( "PruebaParser" )
		{
			add ("Parseado zumbador", testcase (this,
					"pruebaParseadoZumbador", 
						&PruebaParser::pruebaParseadoZumbador));
			add ("Parseado pulsador", testcase (this,
					"pruebaParseadoPulsador", 
						&PruebaParser::pruebaParseadoPulsador));
			add ("Parseado Erroneo", testcase (this,
					"pruebaParseadoErroneo", 
						&PruebaParser::pruebaParseadoErroneo));
			add ("Parseado motor", testcase (this,
					"pruebaParseadoMotor", 
						&PruebaParser::pruebaParseadoMotor));
			add ("Parseado reed", testcase (this,
					"pruebaParseadoReed", 
						&PruebaParser::pruebaParseadoReed));
			add ("Parseado rele", testcase (this,
					"pruebaParseadoRele", 
						&PruebaParser::pruebaParseadoRele));
			add ("Parseado contador", testcase (this,
					"pruebaParseadoContador", 
					&PruebaParser::pruebaParseadoContador));
			add ("Parseado temporizador", testcase (this,
					"pruebaParseadoTemporizador", 
					&PruebaParser::pruebaParseadoTemporizador));
			add ("Parseado biestable", testcase (this,
					"pruebaParseadoBiestable", 
					&PruebaParser::pruebaParseadoBiestable));
			add ("Parseado vector", testcase (this,
					"pruebaParseadoVector", 
					&PruebaParser::pruebaParseadoVector));
			add ("Parseado relacion", testcase (this,
					"pruebaParseadoRelacion", 
					&PruebaParser::pruebaParseadoRelacion));
			add ("Parseado electroiman", testcase (this,
					"pruebaParseadoElectroiman", 
					&PruebaParser::pruebaParseadoElectroiman));
			suite::main().add("PruebaParser", this);
		}
	
	};
	PruebaParser* pruebaParser= new PruebaParser();	
}
