#include "unit++.h"
#include "sistema.h"
#include "pulsador.h"
#include "lampara.h"
#include "fotosensor.h"
#include "biestable.h"
#include "rele.h"
#include "parser.h"
#include "contador.h"

using namespace unitpp;

namespace
{
	class PruebaSistema: public suite
	{
		void PruebaSistemaSimple()
		{
			Conexion* c1=new Conexion (CONEXION_INACTIVA);
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			Voltaje *v1=new Voltaje(0.0);
			Voltaje *v2=new Voltaje(5.0);
			
			Pulsador* p=new Pulsador(c1,v1,c2,v2);	
			p->setNombreElemento("Pulsador 1");
			Sistema* s=new Sistema();
			s->anadirElemento(p);
			
			/*	Se activa el pulsador */
			p->setEntrada(c2);
			
			/*	Y queremos conocer la entrada del pulsador */
			Senal* entrada= s->getEntradaPorNombre("Pulsador 1");
			

		}
		
		/*	En este test se va a meter un sistema dentro de otro
			El sistema S1 contiene un pulsador conectado a una lampara
			El sistema S2 contiene un fotosensor
			El sistema Sgrande contendra a S1 y S2*/
		void PruebaSistemaRecursivo()
		{
			

		}
		/*	En este metodo se conecta un biestable a un rele, el rele
			a un pulsador y el pulsador a una lampara. La salida de la 
			lampara debe ser correcta*/
			 
		void PruebaSistemaBiestable()
		{

		}
		/*	En este metodo creamos un fotosensor que ir dentro de su
			propio sistema S2. En el sistema S1 metemos un biestable
			con una lampara y el sistema S2 se suscribe a la salida de la
			lampara. S1 y S2 se meten en un solo sistema grande Sgrande
			a traves del cual interactuaremos*/
		void PruebaSistemaCompuesto()
		{

		}
		void PruebaSistemaImbuido()
		{

		}				
		void PruebaPulsadorContador()
		{

		}
		public:
			PruebaSistema(): suite ("Prueba del sistema")
			{
				add ("Prueba pulsaciones", testcase (this, 
					"Pruebapulsacion", &PruebaSistema::PruebaSistemaSimple));
				add ("Prueba de un sistema compuesto", testcase (this, 
					"PruebaSistemaRecursivo",
					 &PruebaSistema::PruebaSistemaRecursivo));
				add ("Prueba sistema con biestable", testcase (this, 
					"PruebaSistemaConBiestable",
					 &PruebaSistema::PruebaSistemaBiestable));
				add ("Prueba sistema retrocompuesto", testcase (this, 
					"PruebaSistemaConBiestable",
					 &PruebaSistema::PruebaSistemaCompuesto));
				add ("Prueba recursion multiple", testcase (this, 
					"PruebaSistemaImbuido",
					 &PruebaSistema::PruebaSistemaImbuido));
				add ("Prueba pulsador->contador", testcase (this, 
					"PruebaPulsadorContador",
					 &PruebaSistema::PruebaPulsadorContador));
				suite::main().add ("PruebaSistema", this);
			}
	};
	
	PruebaSistema* pps=new PruebaSistema();	
}
