#include "unit++.h"
#include "sistema.h"
#include "pulsador.h"
#include "biestable.h"

using namespace unitpp;

namespace
{
	class PruebaAvanzada: public suite
	{
		void PruebaAnadido()
		{
			Conexion* c1=new Conexion (CONEXION_INACTIVA);
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  v1=new Voltaje  (0.0);
			Voltaje*  v2=new Voltaje  (5.0);
			Pulsador* p;
			char numerico[10]="";
			Sistema* s=new Sistema();
			string nombre("Pulsador ");
			
			for (int i=1; i<100; i++ )
			{
				p=new Pulsador(c1,v1,c2,v2);
				sprintf(numerico, "%i", i);
				string sufijo(numerico);
				string nombreElemento(nombre+numerico);
				p->setNombreElemento(nombreElemento.c_str());
				s->anadirElemento(p);	
			}
			printf ("Destruyendo sistema con 100 elementos..");
			delete s;
			printf ("destruido!\n");
		}
		
		void PruebaDestruccion()
		{
			Conexion* c1=new Conexion (CONEXION_INACTIVA);
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  v1=new Voltaje  (0.0);
			Voltaje*  v2=new Voltaje  (5.0);
			Pulsador* p;
			p=new Pulsador(c1,v1,c2, v2);
			Voltaje*  activar1	=	new Voltaje (3.2);
			Voltaje*  desactivar1=	new Voltaje (0.0);
			Voltaje*  activar2	=	new Voltaje (3.2);
			Voltaje*  desactivar2=	new Voltaje (0.0);
			Voltaje*  activar3	=	new Voltaje (3.2);
			Voltaje*  desactivar3=	new Voltaje (0.0);
			Voltaje*  activar4	=	new Voltaje (3.2);
			Voltaje*  desactivar4=	new Voltaje (0.0);
			
			Biestable* b=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
				
			p->setNombreElemento ("El pulsador");
			b->setNombreElemento ("El biestable");
			p->anadirSuscriptor (b);
			
			
			Sistema* s=new Sistema();
			s->anadirElemento(p);
			s->anadirElemento(b);
			s->setNombreElemento ("Autodestructor");
			printf ("Listo para destruir sistema con suscriptores...");
			delete s;
			printf ("destruido!\n");
		}
		void pruebaElementos()
		{
			Conexion* c1=new Conexion (CONEXION_INACTIVA);
			Conexion* c2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  v1=new Voltaje  (0.0);
			Voltaje*  v2=new Voltaje  (5.0);
			Pulsador* p;
			p=new Pulsador(c1,v1,c2, v2);
			Voltaje*  activar1	=	new Voltaje (3.2);
			Voltaje*  desactivar1=	new Voltaje (0.0);
			Voltaje*  activar2	=	new Voltaje (3.2);
			Voltaje*  desactivar2=	new Voltaje (0.0);
			Voltaje*  activar3	=	new Voltaje (3.2);
			Voltaje*  desactivar3=	new Voltaje (0.0);
			Voltaje*  activar4	=	new Voltaje (3.2);
			Voltaje*  desactivar4=	new Voltaje (0.0);
			
			Biestable* b=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
				
			p->setNombreElemento ("El pulsador");
			b->setNombreElemento ("El biestable");
			
			Sistema* s=new Sistema();
			s->anadirElemento(p);
			s->anadirElemento(b);
			map<string, Elemento*> elem=s->getElementos();
			map<string, Elemento*>::iterator i;
			for (i=elem.begin(); i!=elem.end(); i++)
			{
				Elemento* e=i->second;
				printf ("Elemento %s\n", e->getNombreElemento());
			}
			Biestable* b1=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			s->anadirElemento(b1);
			Biestable* b2=new Biestable(activar1, desactivar1, 
				activar2,desactivar2, activar3, desactivar3,
				activar4,desactivar4);
			s->anadirElemento(b2);
			printf ("Siguiente intento...");
			elem=s->getElementos();
			for (i=elem.begin(); i!=elem.end(); i++)
			{
				Elemento* e=i->second;
				printf ("Elemento %s\n", e->getNombreElemento());
			}
		}
		public:
			PruebaAvanzada(): suite ("Prueba del sistema")
			{
				add ("Prueba anadido", testcase (this, 
					"Pruebaanadido", &PruebaAvanzada::PruebaAnadido));
				add ("Prueba destruccion de sistema", testcase (this, 
					"Pruebadestruccion", &PruebaAvanzada::PruebaDestruccion));
				add ("Prueba de obtenecion de elementos de sistema", testcase (this, 
					"Prueba Elementos", &PruebaAvanzada::pruebaElementos));
				suite::main().add("PruebaAvanzadaDeSistema", this);
				
			} /* Fin del constructor */
	}; /* Fin de la clase PruebaAvanzada */
	
	PruebaAvanzada* pAvanzada = new PruebaAvanzada();
} /* Fin del namespace */
	
