#include "unit++.h"
#include "contador.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLContador : public suite
	{
		void PruebaValoresContador()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			/* 	Se comprueba primero un fichero con un 
				sistema simple que contiene un nico contador*/
			ficheroCorrecto	=	p->esValido ("xml\\contador.xml");
			if (ficheroCorrecto)
			{
				sistemaParseado=p->getSistema();
				cout << "Sistema XML Contador obtenido" << endl;
				/* 	En este punto deberia haber un contador dentro del
					sistema. El biestable de este fichero se llama 
					"B1" (no modificar los ficheros de test del
					directorio xml) */
				Contador* c = (Contador*)
					sistemaParseado->getRefElementoPorNombre("ContadorX");
				cout << "Examinando voltajes" << endl;
				/* Construimos los valores a mano...*/	
				Voltaje*  v1=new Voltaje  (0.0);
				Voltaje*  v2=new Voltaje  (9.0);
				
				Voltaje  *vEntradaReposo;
				Voltaje  *vEntradaActivacion;
				Voltaje  *vSalidaReposo;
				Voltaje  *vSalidaActivacion;
				
				
				/* 	...y comparo esos valores con los leidos del fichero...*/
				
				vEntradaReposo = c->getVoltajeEntradaReposo();
				assert_eq ("(XML) Voltaje entrada reposo en contador", 
					vEntradaReposo->getValor(), v1->getValor() );
					
				vEntradaActivacion = c->getVoltajeEntradaActivacion();
				assert_eq ("(XML) Voltaje entrada activacion en contador", 
					vEntradaActivacion->getValor(), v2->getValor() );
					
				vSalidaActivacion = c->getVoltajeSalidaActivacion();
				assert_eq ("(XML)Voltaje salida activacion  en contador", 
					vSalidaActivacion->getValor(), v1->getValor() );
					
				vSalidaReposo = c->getVoltajeSalidaReposo();
				assert_eq ("(XML) Voltaje salida activacion en contador", 
					vSalidaReposo->getValor(), v2->getValor() );
				int maxPulsos = c->getMaxPulsos();
				assert_eq ("(XML) Pulsos del contador",
					10, maxPulsos);
				
				p->escribir (sistemaParseado, "xml-resultadoTest-xmlContador.xml");
				delete p;
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLContador() : suite ("Prueba del XML del contador")
			{
				add ("PruebaXMLContador", testcase (this,
					"PruebaXMLContador", 
					&PruebaXMLContador::PruebaValoresContador) );
				
				suite::main().add("PruebaXMLContador", this);
			}
	};
	PruebaXMLContador *pruebaContador=new PruebaXMLContador();	
}
