#include "unit++.h"
#include "lampara.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLLampara : public suite
	{
		void PruebaValoresLampara()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			
			ficheroCorrecto	=	p->esValido ("xml\\lampara.xml");
			if (ficheroCorrecto)
			{
				sistemaParseado=p->getSistema();
								
				/* 	La lampara que hay en el fichero se llama Lamp1
					(no modificar los ficheros de test del
					directorio xml) */
				Lampara* elementoProbado=(Lampara*)
					sistemaParseado->getRefElementoPorNombre("Lamp1");
				
				/* Construimos los valores a mano...*/	
				Luminosidad* l1	=	new Luminosidad("22aa00");
				Luminosidad* l2	=	new Luminosidad("3344a2");
				Voltaje*  v1	=	new Voltaje  (0.0);
				Voltaje*  v2	=	new Voltaje  (9.0);
				
				/* Estos son los valores que sacaremos del XML */
				Luminosidad *d;
				Luminosidad *e;
				Voltaje  *v;
				Voltaje  *w;
				
				/* y comparo esos valores con los leidos del fichero...*/
				d=elementoProbado->getLuminosidadReposo();
				e=elementoProbado->getLuminosidadActivacion();
			
				v=elementoProbado->getVoltajeReposo();
				w=elementoProbado->getVoltajeActivacion();
				
				/* 	Se comprueba si las seales construida y la leida
					del XML son iguales...*/
				bool sonIguales;
				sonIguales=l1->esIgualA (d);
				assert_eq ("Luminosidad en reposo", 
					true, sonIguales );
			
				sonIguales=l2->esIgualA (e);
				assert_eq ("Luminosidad activa", 	 
					true, sonIguales );
			
				assert_eq ("Voltaje en reposo",  v->getValor(), v1->getValor() );
				assert_eq ("Voltaje activacion", w->getValor(), v2->getValor() );	
				
				p->escribir (elementoProbado, "xml-resultadoTest-xmlLampara.xml");
				delete p;
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLLampara() : suite ("Prueba del XML de lampara")
			{
				add ("PruebaXMLLampara", testcase (this,
					"PruebaXMLLampara", 
					&PruebaXMLLampara::PruebaValoresLampara) );
				
				suite::main().add("PruebaXMLLampara", this);
			}
	};
	PruebaXMLLampara *prLampara=new PruebaXMLLampara();	
}
