#include "unit++.h"
#include "motor.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLMotor : public suite
	{
		void PruebaValoresMotor()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			/* 	Se comprueba primero un fichero con un 
				motor de ejemplo*/
			ficheroCorrecto	=	p->esValido ("xml\\motor.xml");
			if (ficheroCorrecto)
			{
				sistemaParseado=p->getSistema();
				cout << "Sistema XML Motor obtenido" << endl;
				/* 	En este punto deberia motor dentro del sistema
					(no modificar los ficheros de test del
					directorio xml) */
				Motor* r = (Motor*)
					sistemaParseado->getRefElementoPorNombre("motorX");
				cout << "Examinando voltajes" << endl;
				/* Construimos los valores de comparacion a mano...*/	
				Voltaje*  	v1 = new Voltaje  (0.0);
				Voltaje*  	v2 = new Voltaje  (9.0);
				Voltaje*	v3 = new Voltaje  (-9.0);
				
				Giro*		g1=  new Giro ("stop");
				Giro*		g2=	 new Giro ("cw");
				Giro*		g3=  new Giro ("ccw");
				//Valores que leemos y compararemos con los construidos
				//para comprobar si son iguales
				Voltaje*	vEntradaReposo;
				Voltaje*	vEntradaGiroCW;
				Voltaje*	vEntradaGiroCCW;
				Giro*		gSalidaStop;
				Giro*		gSalidaCW;
				Giro*		gSalidaCCW;
				
				/* 	...y comparo esos valores con los leidos del fichero...*/
				
				vEntradaReposo = r->getVoltajeReposo();
				assert_eq ("(XML) Voltaje entrada reposo en Motor", 
					vEntradaReposo->getValor(), v1->getValor() );
				
				vEntradaGiroCW	= r->getVoltajeGiroCW();
				assert_eq ("(XML) Voltaje entrada giro cw en Motor", 
					vEntradaGiroCW->getValor(), v2->getValor() );
				
				vEntradaGiroCCW	= r->getVoltajeGiroCCW();
				assert_eq ("(XML) Voltaje entrada giro ccw en Motor", 
					vEntradaGiroCCW->getValor(), v3->getValor() );
					
				gSalidaStop = r->getGiroReposo();
				assert_eq ("(XML) Motor: Giro reposo",
					g1->getValor(), gSalidaStop->getValor() );
					
				gSalidaCW	= r->getGiroCW();
				assert_eq ("(XML) Motor: Giro cw",
					g3->getValor(), gSalidaCW->getValor() );
					
				gSalidaCCW	= r->getGiroCCW();
				assert_eq ("(XML) Motor: Giro ccw",
					g2->getValor(), gSalidaCCW->getValor() );
				p->escribir (r, "xml-resultadoTest-xmlMotor.xml");
				delete p;
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLMotor() : suite ("Prueba del XML del motor")
			{
				add ("PruebaXMLMotor", testcase (this,
					"PruebaXMLMotor", 
					&PruebaXMLMotor::PruebaValoresMotor) );
				
				suite::main().add("PruebaXMLMotor", this);
			}
	};
	PruebaXMLMotor *prMotor=new PruebaXMLMotor();	
}
