#include "unit++.h"
#include "pulsador.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLPulsador : public suite
	{
		void PruebaValoresPulsador()
		{
			bool ficheroCorrecto = false;
			Parser* parser=new Parser();
			Sistema* sistemaParseado;
			cout << "validando pulsador.xml...\n";
			/* 	Se comprueba primero un fichero con un 
				sistema simple que contiene un nico pulsador*/
			ficheroCorrecto	=	parser->esValido ("xml\\pulsador.xml");
			cout << "Pulsador.xml valido\n";
			if (ficheroCorrecto)
			{
				sistemaParseado=parser->getSistema();
				
				/* 	En este punto deberia haber un pulsador dentro del
					sistema. El pulsador de este fichero se llama 
					"Pulsador1" (no modificar los ficheros de test del
					directorio xml) */
				cout << "Obteniendo pulsador\n";
				Pulsador* p=(Pulsador*)
					sistemaParseado->getRefElementoPorNombre("Pulsador1");
				cout << "Pulsador obtenido\n";
				/* Construimos los valores a mano...*/	
				Conexion* c1=new Conexion (CONEXION_INACTIVA);
				Conexion* c2=new Conexion (CONEXION_ACTIVA);
				Voltaje*  v1=new Voltaje  (0.0);
				Voltaje*  v2=new Voltaje  (9.0);
				
				
				Conexion *d;
				Conexion *e;
				Voltaje  *v;
				Voltaje  *w;
				
				/* y comparo esos valores con los leidos del fichero...*/
				d=p->getConexionReposo();
				e=p->getConexionActivacion();
			
				v=p->getVoltajeReposo();
				w=p->getVoltajeActivacion();
				
				assert_eq ("Conexion en reposo", d->getValor(), c1->getValor() );
				assert_eq ("Conexion activa", 	 e->getValor(), c2->getValor() );
			
				assert_eq ("Voltaje en reposo",  v->getValor(), v1->getValor() );
				assert_eq ("Voltaje activacion", w->getValor(), v2->getValor() );	
				
				parser->escribir(p, "xml-resultadoTest-xmlpulsador.xml");
				
				delete parser;
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLPulsador() : suite ("Prueba del XML del pulsador")
			{
				add ("PruebaXMLPulsador", testcase (this,
					"PruebaXMLPulsador", 
					&PruebaXMLPulsador::PruebaValoresPulsador) );
				
				suite::main().add("PruebaXMLPulsador", this);
			}
	};
	PruebaXMLPulsador *prPulsador=new PruebaXMLPulsador();	
}
