#include "unit++.h"
#include "rele.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLRele : public suite
	{
		void PruebaValoresRele()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			/* 	Se comprueba primero un fichero con un 
				sistema simple que contiene un rele*/
			ficheroCorrecto	=	p->esValido ("xml\\rele.xml");
			if (ficheroCorrecto)
			{
				sistemaParseado=p->getSistema();
				cout << "Sistema XML Rele obtenido" << endl;
				/* 	En este punto deberia haber un reed dentro del
					sistema. El reed de este fichero se llama 
					"sensormagnetico" (no modificar los ficheros de test del
					directorio xml) */
				Rele* r = (Rele*)
					sistemaParseado->getRefElementoPorNombre("Rele1");
				cout << "Examinando voltajes" << endl;
				/* Construimos los valores de comparacion a mano...*/	
				Voltaje*  	v1 = new Voltaje  (0.0);
				Voltaje*  	v2 = new Voltaje  (9.0);
				Conexion* m1 = new Conexion (false);
				Conexion* m2 = new Conexion (true);
				
				//Valores que leemos y compararemos con los construidos
				//para comprobar si son iguales
				Voltaje*	vSalidaReposo;
				Voltaje*	vSalidaActivacion;
				Conexion* 	conEntradaReposo;
				Conexion* 	conEntradaActivacion;
				
				
				/* 	...y comparo esos valores con los leidos del fichero...*/
				
				vSalidaReposo = r->getVoltajeReposo();
				assert_eq ("(XML) Voltaje salida reposo en Rele", 
					vSalidaReposo->getValor(), v1->getValor() );
					
				vSalidaActivacion = r->getVoltajeActivacion();
				assert_eq ("(XML) Voltaje salida activacion en Rele", 
					vSalidaActivacion->getValor(), v2->getValor() );					
				p->escribir(r, "xml-resultadoTest-xmlrele.xml");
				delete p;
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLRele() : suite ("Prueba del XML del rele")
			{
				add ("PruebaXMLRele", testcase (this,
					"PruebaXMLRele", 
					&PruebaXMLRele::PruebaValoresRele) );
				
				suite::main().add("PruebaXMLRele", this);
			}
	};
	PruebaXMLRele *prRele=new PruebaXMLRele();	
}
