#include "unit++.h"
#include "sistema.h"
#include "pulsador.h"
#include "lampara.h"
#include "parser.h"
#include <iostream>

using namespace std;
using namespace unitpp;

namespace
{
	
	class PruebaXMLSistema : public suite
	{
		/*	En este metodo se construyen un pulsador y una lampara. El
			pulsador va conectado a la lampara, de forma que cuando se
			pulsa se enciende la lampara. Estos dos elementos se introducen
			en un sistema y se escribe la representacion XML del sistema */
		void PruebaXMLSistemaNoCompuesto()
		{
			Parser* parser=new Parser();			
			//Construimos un pulsador...
			Conexion* con1=new Conexion (CONEXION_INACTIVA);
			Conexion* con2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  vol1=new Voltaje  (0.0);
			Voltaje*  vol2=new Voltaje  (5.0);
			
			Pulsador* p=new Pulsador(con1,vol1,con2,vol2);
			p->setNombreElemento ("Pulsador-A");
			
			//Construimos una lampara...
			Voltaje*	v1=new Voltaje (0.0);
			Voltaje*	v2=new Voltaje (5.0);
			Luminosidad*l1=new Luminosidad("OFF");
			Luminosidad*l2=new Luminosidad("Rojo");
			
			Lampara* lamp=new Lampara(v1,l1,v2,l2);
			lamp->setNombreElemento ("Lampara-B");
			
			//Conectamos el pulsador a la lampara..
			p->anadirSuscriptor (lamp);
			
			//Y creamos un sistema que los contenga a los dos...
			Sistema* s=new Sistema();
			s->anadirElemento (p);
			s->anadirElemento (lamp);
			s->setNombreElemento ("Sistema-de-prueba");
			printf ("Escribiendo sistema...");
			parser->escribir ( s, "xml-resultadoTest-xmlSistema.xml");
			printf ("Sistema escrito!\n\n\n\n");
			//Se liberan los recursos utilizados...			
			
			delete s;
			delete parser;
			printf ("Elementos liberados l4\n");
		}
		
		void testGetXMLSistema()
		{
			Parser* parser=new Parser();			
			//Construimos un pulsador...
			Conexion* con1=new Conexion (CONEXION_INACTIVA);
			Conexion* con2=new Conexion (CONEXION_ACTIVA);
			Voltaje*  vol1=new Voltaje  (0.0);
			Voltaje*  vol2=new Voltaje  (5.0);
			
			Pulsador* p=new Pulsador(con1,vol1,con2,vol2);
			p->setNombreElemento ("Pulsador-A");
			
			//Construimos una lampara...
			Voltaje*	v1=new Voltaje (0.0);
			Voltaje*	v2=new Voltaje (5.0);
			Luminosidad*l1=new Luminosidad("OFF");
			Luminosidad*l2=new Luminosidad("Rojo");
			
			Lampara* lamp=new Lampara(v1,l1,v2,l2);
			lamp->setNombreElemento ("Lampara-B");
			
			//Conectamos el pulsador a la lampara..
			p->anadirSuscriptor (lamp);
			
			//Y creamos un sistema que los contenga a los dos...
			Sistema* s=new Sistema();
			s->anadirElemento (p);
			s->anadirElemento (lamp);
			s->setNombreElemento ("Sistema de prueba");
			
			char* xml= s->getCadenaXML();
			
			printf ("---Sistema XML---\n");
			printf ("%s", xml);
			printf ("\n---Sistema XML---\n");
		}
		public:
			PruebaXMLSistema() : suite ("XML del sistema")
			{
				add ("XMLSistema", testcase (this,
					"XMLSistema", 
					&PruebaXMLSistema::PruebaXMLSistemaNoCompuesto) );
				
				add ("Cadena XML del Sistema", testcase (this,
					"XMLSistema", 
					&PruebaXMLSistema::testGetXMLSistema) );
					
				suite::main().add("PruebaXMLSistema", this);
			}
	};
	
	PruebaXMLSistema *sistemaXML=new PruebaXMLSistema();	
	
}
